Lua_AttrIconItem = class("Lua_AttrIconItem", Lua_DisplayObject)
function Lua_AttrIconItem:ctor(p)
	self.pivot = 0;
	self.spacingX = 5;
	self:superCall("ctor", p);
end

function Lua_AttrIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);

	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22);
	self.text.horizontalOverflowValue = 1;
	self.text.verticalOverflowValue = 1;
end

function Lua_AttrIconItem:dispose()
	self:superCall("dispose");
end

-- 1:从左往右 0:居中 -1:从右往左
function Lua_AttrIconItem.Set:pivot(val)
    self._pivot = val;
end

-- function Lua_AttrIconItem.Get:pivot()
--     return self._pivot;
-- end

function Lua_AttrIconItem.Set:spacingX(val)
    self._spacingX = val;
end

-- function Lua_AttrIconItem.Get:spacingX()
--     return self._spacingX;
-- end

function Lua_AttrIconItem:setTextStyle(fontName, fontSize, colorStr, effectStyle, effectColorStr)
	fontName = fontName == nil and Lua_MyUISettings.defaultFontName or fontName
	fontSize = fontSize == nil and 22 or fontSize;
	colorStr = colorStr == nil and "FFFFFF" or colorStr;
	effectStyle = effectStyle == nil and 0 or effectStyle;
	effectColorStr = effectColorStr == nil and "000000" or effectColorStr;

	self.text.fontName = fontName;
	self.text.fontSize = fontSize;
	self.text.colorStr = Lua_ColorDefine.transColorStr(colorStr);
    self.text.effectStyle = effectStyle;
    self.text:setEffectDistance(2, 2);
    self.text.effectColorStr = Lua_ColorDefine.transColor(effectColorStr);
end

function Lua_AttrIconItem:setData(iconAtlas, iconSprite, text)
	local iconWidth;
	if strIsNullOrEmpty(iconAtlas) or strIsNullOrEmpty(iconSprite) then
		self.icon:setEnable(false);
		iconWidth = 0;
	else
		self.icon:setEnable(true);
		self.icon:setAltas(iconAtlas, iconSprite);
		iconWidth = self.icon.width;
	end

	self.text.text = text;
	self.text:resetSize();
	local textWidth = self.text.width;
	local spacingX = iconWidth > 0 and self._spacingX or 0;

	if self._pivot == 1 then
		self.icon.pivotValue = 3;
		self.icon:setLocation(0, 0, 0);

		self.text.pivotValue = 3;
		self.text.alignmentValue = 3;
		self.text:setLocation(iconWidth + spacingX, 0, 0);
	elseif self._pivot == -1 then
		self.text.pivotValue = 5;
		self.text.alignmentValue = 5;
		self.text:setLocation(0, 0, 0);

		self.icon.pivotValue = 5;
		self.icon:setLocation(-textWidth + spacingX, 0, 0);
	else
		local width = (iconWidth + textWidth) / 2;
		self.icon.pivotValue = 3;
		self.icon:setLocation(-width - spacingX / 2, 0, 0);

		self.text.pivotValue = 3;
		self.text:setLocation(-width + iconWidth + spacingX / 2, 0, 0);
	end
end