-- 兑换活动
Lua_CashRewardData = class("Lua_CashRewardData")
function Lua_CashRewardData:ctor()
	self:dispose();
end

function Lua_CashRewardData:dispose()
	self.cashRewardDir = nil;
	self.shopItemDir = nil;
end

function Lua_CashRewardData:fromServer50108058(msg)
	if msg == nil then
		return;
	end

	if self.cashRewardDir == nil then
		self.cashRewardDir = {};
	end

	local obj;
	local key;
	local value;
	local activeId = tonumber(msg.active_id);

	local data = self:getCashRewardDataByActiveId(activeId);

	local previewRewards = {};
	local obj = msg.show_reward;
	for i = 1, #obj do
		key = tonumber(obj[i].key);
		previewRewards[#previewRewards + 1] = key;
	end
	if data == nil then
		data = {
			activeId = activeId, 
			dropCloseTime = tonumber(msg.close_show) or 0,
			bFirstLogin = msg.first_login == 0, -- 本日首次登陆
			costId = tonumber(msg.cost_item),
			previewRewards = previewRewards,
			shopItems = {}
		}
		self.cashRewardDir[activeId] = data;
	else
		data.activeId = activeId;
		data.dropCloseTime = tonumber(msg.close_show) or 0;
		data.bFirstLogin = msg.first_login == 0;
		data.costId = tonumber(msg.cost_item);
		data.previewRewards = previewRewards;
		data.shopItems = {};
	end
	local shopItems = data.shopItems;

	-- 商品道具
	if self.shopItemDir == nil then
		self.shopItemDir = {};
	end

	self.shopItemDir[activeId] = {};

	obj = msg.cash_item;
	for i = 1, #obj do
		key = tonumber(obj[i].id);
		data = {
			id = key,
			costId = tonumber(obj[i].item_id),
			costCount = obj[i].amount or 1,
			limitCount = obj[i].limit_times or 0,
			buyTime = obj[i].times or 1,
			price = obj[i].recharge or 1,
			recommend = obj[i].recommend == 1
		}

		self.shopItemDir[activeId][key] = data;
		shopItems[#shopItems + 1] = key;
	end
	table.sort( shopItems, function(a, b) 
			return a < b;
		end
		)
end

function Lua_CashRewardData:getCashRewardDataByActiveId(activeId)
	if self.cashRewardDir == nil or self.cashRewardDir[activeId] == nil then
		return;
	end

	return self.cashRewardDir[activeId];
end

function Lua_CashRewardData:getSingleShopItem(activeId, shopId)
	if self.shopItemDir == nil or self.shopItemDir[activeId] == nil or self.shopItemDir[activeId][shopId] == nil then
		return;
	end

	return self.shopItemDir[activeId][shopId];
end

function Lua_CashRewardData:checkShopBtnRedPoint(activeId)
	local activityData = DataCenter.cashRewardData:getCashRewardDataByActiveId(activeId); 
	if activityData == nil then
		return;
	end

	local shopItems = activityData.shopItems;
	local costId = activityData.costId;
	local hasCount = DataCenter.packData:getItemCountById(costId);
	local hasReward;
	if shopItems ~= nil then
		local item;
		for i = 1, #shopItems do
			item = self:getSingleShopItem(activeId, shopItems[i]);
			if item ~= nil and item.recommend and item.limitCount > item.buyTime and item.price <= hasCount then
				hasReward = true;
				break;
			end
		end
	end
	return hasReward;
end