checkRequire("Lua_DivineDomainTrialData");
checkRequire("Lua_DivineDomainTrialUtil");
Lua_DivineDomainTrialProxy = class("Lua_DivineDomainTrialProxy");
function Lua_DivineDomainTrialProxy:ctor()
	DataCenter.divineDomainTrialData = Lua_DivineDomainTrialData:new();
	DataCenter.divineDomainTrialUtil = Lua_DivineDomainTrialUtil.new();

	Lua_MsgUtil.addLuaMsg(50210001, self, self.rGetDivineDomainInfo); --请求神域试炼界面(返回)
	Lua_MsgUtil.addLuaMsg(50210002, self, self.rGetSelectBuffsInfo); --请求增益界面(返回)
	Lua_MsgUtil.addLuaMsg(50210003, self, self.rGetSelectedBuffInfo); --请求选择增益(返回)
	Lua_MsgUtil.addLuaMsg(50210004, self, self.rGetSLevelRecordInfo); --请求神域试炼通关记录(返回)
	Lua_MsgUtil.addLuaMsg(50210005, self, self.rGetRankInfo); --请求神域试炼排行榜界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50210006, self, self.rGetReflashBuffInfo); --请求刷新增益界面(返回)
	Lua_MsgUtil.addLuaMsg(50210007, self, self.rGetAcheiveRewardInfo); --请求神域试炼成就奖励界面(返回)
	Lua_MsgUtil.addLuaMsg(50210009, self, self.rGetRecommendInfo); --请求神域试炼阵容推荐界面(返回)
	Lua_MsgUtil.addLuaMsg(50210011, self, self.rNoticeBossReset); --请求神域试炼阵容推荐界面(返回)
	
	
	Lua_MsgUtil.addLuaMsg(80210001, self, self.rNoticeResetInfo); --通知神域试炼每日刷新

end



---------------------------------------请求--------------------------------
-- 请求神域试炼界面
function Lua_DivineDomainTrialProxy:sGetDivineDomainInfo(type) 
	local cmd = ProtoPublic_pb.Proto10210001();
    cmd.type = type;
    sendMsg(10210001, cmd);
end

-- 请求增益界面
function Lua_DivineDomainTrialProxy:sGetSelectBuffsInfo(type) -- 1 普通 2特殊
	local cmd = ProtoPublic_pb.Proto10210002();
	cmd.type = type;
    sendMsg(10210002, cmd);
end

-- 请求选择增益
function Lua_DivineDomainTrialProxy:sGetSelectedBuffInfo(buff_id, type) 
	local cmd = ProtoPublic_pb.Proto10210003();
	cmd.buff_id = buff_id;
	cmd.type = type; -- 1 普通 2特殊
    sendMsg(10210003, cmd);
end

-- 请求神域试炼通关记录
function Lua_DivineDomainTrialProxy:sGetSLevelRecordInfo(stage) 
	local cmd = ProtoPublic_pb.Proto10210004();
	cmd.stage = stage;
    sendMsg(10210004, cmd);
end

-- 请求神域试炼排行榜界面信息
function Lua_DivineDomainTrialProxy:sGetRankInfo()
    sendMsg(10210005);
end

-- 请求刷新增益界面
function Lua_DivineDomainTrialProxy:sGetReflashBuffInfo(type) 
	local cmd = ProtoPublic_pb.Proto10210006();
	cmd.type = type;
    sendMsg(10210006, cmd);
end

-- 请求神域试炼成就奖励界面
function Lua_DivineDomainTrialProxy:sGetAcheiveRewardInfo(reward_type) 
	local cmd = ProtoPublic_pb.Proto10210007();
	cmd.reward_type = reward_type;
    sendMsg(10210007, cmd);
end

-- 请求领取神域试炼成就奖励
function Lua_DivineDomainTrialProxy:sReceiveAcheiveRewardInfo(reward_id, reward_type) 
	local cmd = ProtoPublic_pb.Proto10210008();
	cmd.reward_id = reward_id;
	cmd.reward_type = reward_type;
    sendMsg(10210008, cmd);
end

-- 请求神域试炼阵容推荐界面
function Lua_DivineDomainTrialProxy:sGetRecommendInfo(stage) 
	local cmd = ProtoPublic_pb.Proto10210009();
	cmd.stage = stage; -- 关卡id
    sendMsg(10210009, cmd);
end


-- 请求点赞排行榜玩家
function Lua_DivineDomainTrialProxy:sAdmirePlayer(player_id) 
	local cmd = ProtoPublic_pb.Proto10210010();
	cmd.player_id = player_id;
    sendMsg(10210010, cmd);
end

-- 请求特殊关卡敌方增益界面
function Lua_DivineDomainTrialProxy:sNoticeBossReset(flag) 
    local cmd = ProtoPublic_pb.Proto10210011();
    cmd.flag = flag or 0;
    sendMsg(10210011, cmd);
end





---------------------------------------返回--------------------------------
--请求神域试炼界面(返回)
function Lua_DivineDomainTrialProxy:rGetDivineDomainInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210001();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210001(msg);
        Lua_MsgUtil.callFunc("UPDATE_DIVINEDOMAINTRIAL_TRIAL_DATA");
    end
end

--请求增益界面(返回)
function Lua_DivineDomainTrialProxy:rGetSelectBuffsInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210002();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210002(msg);

        Lua_MsgUtil.callFunc("REQUIRE_DIVINEDOMAINTRIAL_BUFF");
    end
end

--请求选择增益(返回)
function Lua_DivineDomainTrialProxy:rGetSelectedBuffInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210003();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210003(msg);
        Lua_MsgUtil.callFunc("UPDATE_DIVINEDOMAINTRIAL_SELECTED_BUFF");
    end
end

--请求神域试炼通关记录(返回)
function Lua_DivineDomainTrialProxy:rGetSLevelRecordInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210004();
        msg:ParseFromString(mp.data);

        -- 打开通关记录窗口
        Lua_WindowUtil.openWin("Lua_DivineDomainTrialPassRecordWindow", Lua_WinParam.ACTION_OPEN, msg); 
    end
end

--请求神域试炼排行榜界面信息(返回)
function Lua_DivineDomainTrialProxy:rGetRankInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210005();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("DIVINEDOMAINTRIAL_RANK_UPDATE", msg);
    end
end

--请求刷新增益界面(返回)
function Lua_DivineDomainTrialProxy:rGetReflashBuffInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210006();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210006(msg);
        Lua_MsgUtil.callFunc("UPDATE_DIVINEDOMAINTRIAL_BUFF", true);
        Lua_MsgUtil.callFunc("UPDATE_DIVINEDOMAINTRIAL_SELECTED_BUFF");
    end
end

-- 通知神域试炼每日刷新
function Lua_DivineDomainTrialProxy:rNoticeResetInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80210001();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer80210001(msg);
        Lua_MsgUtil.callFunc("NOTICE_RESET_DIVINEDOMAINTRIAL");
    end
end

-- 请求神域试炼成就奖励界面(返回)
function Lua_DivineDomainTrialProxy:rGetAcheiveRewardInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210007();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210007(msg);
        Lua_MsgUtil.callFunc("UPDATE_DIVINEDOMAINTRIAL_REWARD");
    end
end

-- 请求神域试炼阵容推荐界面(返回)
function Lua_DivineDomainTrialProxy:rGetRecommendInfo(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210009();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_DivineDomainTrialRecommendWindow", Lua_WinParam.ACTION_OPEN, msg);
    end
end


-- 通知服务端特殊关卡重置时boss特性变更时窗口已打开
function Lua_DivineDomainTrialProxy:rNoticeBossReset(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50210011();
        msg:ParseFromString(mp.data);
        DataCenter.divineDomainTrialData:fromServer50210011(msg);
    end
end