-- 欧皇招募
Lua_EuropeanRecruitData = class("Lua_EuropeanRecruitData");
function Lua_EuropeanRecruitData:ctor()
	-- self:dispose();
end

function Lua_EuropeanRecruitData:dispose()
	-- self.activeId = nil; -- 活动id
	-- self.receivedNum = 0; -- 领取次数
	-- self.invitationPersonNum = 0; -- 助力人数
	-- self.saveRecordNum = 0; -- 保存的缓存记录
	-- self.residueHelpNum = 0; -- 剩余助力次数
	-- self.residueInvitationNum = 0; -- 剩余邀请次数
	-- self.residueRecruitNum = 0; -- 剩余召唤次数
	self._recordType = nil;
	self._selectedRecordIndex = nil;
	self.recoreInfo = nil;
	self.curEuropeanRecruitResult = nil;
	self.activeId = nil;
end

function Lua_EuropeanRecruitData:fromServer50108071(msg)
	if msg == nil then
		return;
	end

	self.unlockLevelId = msg.unlock_stage; -- 解锁招募关卡id
	self.residueDraw = msg.draw_times; -- 剩余抽卡次数
	self.maxInvitationPersonNum = msg.max_help;
	self.invitationPersonNum = msg.curr_help;
	self.maxSaveRecordNum = msg.max_record;
	self.saveRecordNum = msg.curr_record;
	self.recruit_type = msg.recruit_type;
	self.receivedTime = msg.residue_times;
	self.maxReceivedTime = msg.max_times;
	self.activeId = msg.active_id;
end

function Lua_EuropeanRecruitData:fromServer50108074(msg)
	if msg == nil then
		return;
	end

	self.saveRecordNum = msg.curr_record;
	self.receivedTime = msg.residue_times;
	self.recoreInfo = msg.hero_record;
end

function Lua_EuropeanRecruitData:fromServer50108075(msg)
	if msg == nil then
		return;
	end

	self.saveFlag = msg.save_flag;
end

function Lua_EuropeanRecruitData:getRecordDataByIndex(index)
	if self.recoreInfo == nil or self.recoreInfo[index] == nil then
		return;
	end

	return self.recoreInfo[index];
end

function Lua_EuropeanRecruitData.Get:recordType() -- 1:抽卡过程
	return self._recordType;
end

function Lua_EuropeanRecruitData.Set:recordType(value)
	self._recordType = value;
end

function Lua_EuropeanRecruitData.Get:selectedRecordIndex() -- 选中记录item索引
	return self._selectedRecordIndex;
end

function Lua_EuropeanRecruitData.Set:selectedRecordIndex(value)
	self._selectedRecordIndex = value;
end

function Lua_EuropeanRecruitData:checkRecordData()
	if self.maxSaveRecordNum > self.saveRecordNum and self.recoreInfo == nil then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEuropeanRecruitRecordInfo(self.activeId, 2);
	end
end

function Lua_EuropeanRecruitData:getBlankRecordIndex()
	if self.recoreInfo == nil then
		return;
	end

	if self.maxSaveRecordNum == self.saveRecordNum then
		return;
	end

	local index;
	for i = 1, #self.recoreInfo do
		if self.recoreInfo[i] ~= nil and (self.recoreInfo[i].list == nil or #self.recoreInfo[i].list <= 0) then
			index = i;
			break;
		end
	end

	return index;
end

function Lua_EuropeanRecruitData:setCurEuropeanRecruitResult(heroList)
	self.curEuropeanRecruitResult = heroList;
end

function Lua_EuropeanRecruitData:getEuropeanRecruitActId()
	if self.activeId == nil then
		local iconId = Lua_MenuViewDefine.ICON_EUROPEANRECRUIT;
		local arr = DataCenter.backstageActData:getActArrByMainIconId(iconId);
		if arr ~= nil and arr:getSize() >= 1 then
			self.activeId = arr[1];
		end
	end

	return self.activeId;
end

function Lua_EuropeanRecruitData:checkLevelUnlock()
	local state;
	if self.unlockLevelId ~= nil then
		state = DataCenter.mainLineData:getCheckpointIsCompleted(self.unlockLevelId);
	end

	return state;
end

function Lua_EuropeanRecruitData:checkReceived()
	local bReceived = false;
	if self.receivedTime ~= nil then
		bReceived = self.receivedTime <= 0;
	end

	return bReceived;
end