checkRequire("Lua_CumulateGiftVo");
Lua_CumulateGiftData = class("Lua_CumulateGiftData");
function Lua_CumulateGiftData:ctor()
	self:dispose();
end

function Lua_CumulateGiftData:dispose()
	self.cumulateGiftInfoDic = nil;
	self.showInfoDic = nil;
end

function Lua_CumulateGiftData:fromServer50197018(msg)
	if msg == nil then
		return;
	end

	self:InitConfigInfo();
	self.endTime = msg.close_tick or 0; -- 活动刷新（关闭）时间
	self.index = msg.index; -- 索引id
	self._rechargeDays = msg.index % 1000; -- 当前档次/已累充天数
	self._curRound = Mathf.Floor(msg.index / 1000); -- 当前轮次
	self._rewardKey = self:getRewardKey(self.curRound, msg.world_lvl); -- 活动刷新时世界等级

	local obj
	local vo;
	local redDotState = false;
	for i = 1, #msg.cumulate_list do
		obj = msg.cumulate_list[i];
		vo = self.showInfoDic[obj.key];
		if vo ~= nil then
			vo:updateCumulateGiftVoInfo(obj, msg.money);
			if not redDotState and obj.value == 1 then
				redDotState = true;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_CumulateGift, redDotState or msg.is_first_open == 0);
	
	if self.constConfig.is_stop == 1 then
		local actVo = DataCenter.internalActData:getActivityVo(Lua_ActivityList.ID_CumulateGift);
		actVo:fromServerInfo(0, 0);
	end
end

function Lua_CumulateGiftData.Get:rechargeDays()
	return self._rechargeDays or 0;
end

function Lua_CumulateGiftData.Get:curRound()
	return self._curRound or 1;
end

function Lua_CumulateGiftData.Get:rewardKey()
	if self._rewardKey == nil then
		self._rewardKey = self:getRewardKey(self.curRound, 1);
	end
	return self._rewardKey;
end

function Lua_CumulateGiftData:getRewardKey(curRound, worldLevel)
	local worldLvDic = self.constConfig.world_lvl_reward;
	if worldLvDic == nil then
		return nil;
	end

	local gradeInfo = #worldLvDic < curRound and worldLvDic[#worldLvDic] or worldLvDic[curRound];
	for i = 1, #gradeInfo do
		if worldLevel <= gradeInfo[i][2] then
			return gradeInfo[i][3];
		end
	end
	return worldLvDic[#gradeInfo][3];
end

function Lua_CumulateGiftData.Get:constConfig()
	return getConfig("cumulate_days_recharge", "config");
end

function Lua_CumulateGiftData.Get:showId()
	local list = self.constConfig.show_id_list;
	if #list >= self.curRound then
		return list[self.curRound];
	else
		return list[1];
	end
end

function Lua_CumulateGiftData:InitConfigInfo()
	if self.cumulateGiftInfoDic == nil then
		self.cumulateGiftInfoDic = {};
		self.showInfoDic = {};

		local config = getConfig("cumulate_days_recharge");
		for k,v in pairs(config) do
			if v.round ~= nil then
				if self.cumulateGiftInfoDic[v.round] == nil then
					self.cumulateGiftInfoDic[v.round] = Array();
				end
				self.cumulateGiftInfoDic[v.round]:add(k);
				self.showInfoDic[k] = Lua_CumulateGiftVo.new(k, v);
			end
		end
	end
end

function Lua_CumulateGiftData:getCumulateGiftInfo()
	if self.cumulateGiftInfoDic == nil then
		self:InitConfigInfo();
	end
	if self.cumulateGiftInfoDic[self.curRound] == nil then
		return nil;
	end
	self.cumulateGiftInfoDic[self.curRound]:sortf(self, self.sortFun);
	return self.cumulateGiftInfoDic[self.curRound];
end

function Lua_CumulateGiftData:sortFun(a, b)
	local voA = self.showInfoDic[a];
	local voB = self.showInfoDic[b];
	local _a = voA.sortWeight;
	local _b = voB.sortWeight;
	if _a ~= _b then
		if _b > _a then
			return false;
		end
	else
		if a > b then
			return false;
		end
	end
	return true;
end

function Lua_CumulateGiftData:getCumulateGiftVo(id)
	if self.showInfoDic and self.showInfoDic[id] then
		return self.showInfoDic[id];
	end
	return nil;
end