checkRequire("Lua_RecoverResourcesVo");
Lua_RecoverResourcesData = class("Lua_RecoverResourcesData")
function Lua_RecoverResourcesData:ctor()
end

function Lua_RecoverResourcesData:dispose()
	self._isRecovered = nil;
	self.recoverResourcesDic = nil;
	self._recoverResourcesArr = nil;
	self.mergeTypeDic = nil;
end

function Lua_RecoverResourcesData:fromServer50197056(msg)
	if msg == nil then
		return;
	end

	self.isRecovered = msg.draw_state == 1; -- 0未领取 1已领取

	local obj;
	local vo;
	self.mergeTypeDic = {}
	self._recoverResourcesArr = Array();
	for i = 1, #msg.reward_list do
		obj = msg.reward_list[i];
		vo = self:getRecoverResourcesVo(obj.reward_id);
		if vo == nil then
			vo = Lua_RecoverResourcesVo.new(obj.reward_id);
			self.recoverResourcesDic[obj.reward_id] = vo;
		end
		vo:updateRecoverResourcesVoInfo(obj);

		if self.mergeTypeDic[vo.sort] == nil then
			self.mergeTypeDic[vo.sort] = Array();
			self._recoverResourcesArr:add(vo.sort);
		end
		self.mergeTypeDic[vo.sort]:add(obj.reward_id);
	end
end

function Lua_RecoverResourcesData:getRecoverResourcesVo(id)
	if self.recoverResourcesDic == nil then
		self.recoverResourcesDic = {};
	end
	if id == nil or self.recoverResourcesDic[id] == nil then
		return nil;
	end
	return self.recoverResourcesDic[id];
end

function Lua_RecoverResourcesData:getShowInfoVo(mergeType)
	if mergeType == nil or self.mergeTypeDic == nil or self.mergeTypeDic[mergeType] == nil then
		return nil;
	end
	self.mergeTypeDic[mergeType]:sort(nil, false);
	return self.mergeTypeDic[mergeType];
end

function Lua_RecoverResourcesData.Get:isRecovered()
	return self._isRecovered;
end

function Lua_RecoverResourcesData.Set:isRecovered(value)
	self._isRecovered = value;

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_RecoverResources, not self.isRecovered);
	local vo = DataCenter.internalActData:getActivityVo(Lua_ActivityList.ID_RecoverResources);
	if self.isRecovered then
		vo:fromServerInfo(0, 0);
	else
		vo:fromServerInfo(nil, nil); -- 跨天处理
	end
end

function Lua_RecoverResourcesData.Get:multiple()
	return DataCenter.operationalActUtil:getActConstConfig("recover_resource_multiple", 3) or 0;
end

function Lua_RecoverResourcesData.Get:recoverResourcesArr()
	if self._recoverResourcesArr == nil then
		return nil;
	end
	self._recoverResourcesArr:sort(nil, false);
	return self._recoverResourcesArr;
end