-- 战斗技能
checkRequire("Lua_EffectConfigData");
checkRequire("Lua_AttackTargetInfo");
checkRequire("Lua_AttackShutterInfo");
checkRequire("Lua_SkillEffectConfigData");
checkRequire("Lua_FightCampPosConfig");
checkRequire("Lua_SkillConfigData");
Lua_AttackVo = class("Lua_AttackVo");
function Lua_AttackVo:ctor(sid, fid)
	self:superCall("ctor");

	self:clean();
	self._sceneId = sid;
	self._fightId = fid;
	self.playerMoveToTargetTime = 0.4; -- 角色移动固定时间
	self.effectManager = DataCenter.effectManager;
end

function Lua_AttackVo:dispose()
    if self._bDispose then
        return;
    end

    self._bDispose = true;
    self:resetDir();
    self:clearLuaCallBack();
    self:updateThingMaskAndShowState(false, true, true);
    Lua_CommonUtil.removeTimer(self, self.playSkillFrameScript);
    if self.bShowScreen and self.skillEffData.camActionId ~= nil and self.skillEffData.camActionId > 0 then
        CameraActionController.instance:clean(self.skillEffData.camActionId);
    end

    self.effectManager = nil;
    self._attackPlayer = nil;
    self._targetPlayer = nil;
    self._skillEffData = nil;
    self._skillConfigData = nil;
    if self._targetIds ~= nil then
        self._targetIds:clear();
        self._targetIds = nil;
    end
    if self._targetHurtIds ~= nil then
    	self._targetHurtIds:clear();
    	self._targetHurtIds = nil;
    end
    if self._sectionTargetsDic ~= nil then
    	table.clear(self._sectionTargetsDic);
    	self._sectionTargetsDic = nil;
    end
    if self._shutterList ~= nil then
        local count = self._shutterList:getSize();
        while (count > 0) do
            local info = self._shutterList[count];
            self._shutterList:remove(count);
            DataCenter.fightUtil:returnAttackShutterInfo(info);
            count = count - 1;
        end
        self._shutterList = nil;
    end
end

function Lua_AttackVo:clean()
	self._bDispose = false;
    self._lastTime = 0;
	self._fightId = 0;
	self._sceneId = 0;
	self._attackerId = 0;
	self._playStep = 1;
	self._playActStep = 1;
	self._actAttackedStep = 1;
	self._hurtIdx = 1; --技能伤害索引
	self._preHurtIdx = 1; -- 技能伤害索引
	self._sectionIndex = 1; --技能伤害段数索引
	self._preSectionIndex = 1; -- 技能伤害段数索引
	self._effShowIdx = 1; -- 技能效果展示索引
	self._preEffShowIdx = 1; -- 技能效果展示索引
	self._spd = nil;
	self._spdRate = nil;
	self._countTime = 0;
	self._attackCountTime = 0;
	self._playReleaseEffTime = 0;
	self._actDelayTime = 0;
	self._actAttackedTime = 0;
	self._actPlayTime = 0;
	self._hurtTime = 0;
	self._preHurtTime = 0;
	self._effContactTime = 0;
	self._moveAdditionalTime = 0;
	self._playerMoveTime = 0;
	self._moveDelayTime = 0;
	self._moveStartTime = 0;
	self._bMoveToTarget = false;
	self._moveStartPosX = 0;
	self._moveStartPosY = 0;
	self._moveStartPosZ = 0;
	self._moveTargetPosX = 0;
	self._moveTargetPosY = 0;
	self._moveTargetPosZ = 0;
	self._bShowScreen = false;
	self.isTrunRound = false;
	self._targetCount = 0;
	self._maxSecIdx = 0;
	self._minTargetsPos = nil;
	self._maxTargetsPos = nil;
	if self._targetIds ~= nil then
        self._targetIds:clear();
    end
    if self._targetHurtIds ~= nil then
    	self._targetHurtIds:clear();
    end
    if self._sectionTargetsDic ~= nil then
    	table.clear(self._sectionTargetsDic);
    	self._sectionTargetsDic = nil;
    end
    if self._shutterList ~= nil then
        local count = self._shutterList:getSize();
        while (count > 0) do
            local info = self._shutterList[count];
            self._shutterList:remove(count);
            DataCenter.fightUtil:returnAttackShutterInfo(info);
            count = count - 1;
        end
    end

    self._attackPlayer = nil;
    self._targetPlayer = nil;
    self._skillEffData = nil;
    self._skillConfigData = nil;
    self:clearLuaCallBack();
    Lua_CommonUtil.removeTimer(self, self.playSkillFrameScript);
end

function Lua_AttackVo:setId(sid, fid)
	self._sceneId = sid;
	self._fightId = fid;
end

function Lua_AttackVo.Get:sceneId()
    return self._sceneId;
end

function Lua_AttackVo.Get:fightId()
    return self._fightId;
end

function Lua_AttackVo.Get:bShowScreen()
	return self._bShowScreen;
end

function Lua_AttackVo.Set:bShowScreen(value)
	if self._bShowScreen ~= value then
		self._bShowScreen = value;
		if self.skillEffData ~= nil and self.skillEffData.camActionId ~= nil and self.skillEffData.camActionId > 0 then
            if value and self._countTime > 0 then
                local formationType = self.attackPlayer ~= nil and self.attackPlayer.formationType or 0;
                CameraActionController.instance:playSeries(self.skillEffData.camActionId, self._attackCountTime - self._countTime, self.speedRate, formationType);
            else
                CameraActionController.instance:clean(self.skillEffData.camActionId);
            end
        end
	end
end

function Lua_AttackVo.Set:speed(value)
	self._spd = value > 0 and value or 1;
end

function Lua_AttackVo.Get:speed()
	if self._spd == nil then
		local rvo = DataCenter.fightData:getRecordVoById(self.fightId);
		if rvo ~= nil then
			self._spd = rvo.speed;
			self._spdRate = rvo.speedRate;
		elseif self.attackPlayer ~= nil then
            self._spd = self.attackPlayer.data.aniSpeed;
            self._spdRate = self.attackPlayer.data.aniSpdRate;
        elseif self.targetPlayer ~= nil then
            self._spd = self.targetPlayer.data.aniSpeed;
            self._spdRate = self.targetPlayer.data.aniSpdRate;
        else
            self._spd = 1;
            self._spdRate = 1;
        end
	end
	return self._spd;
end

function Lua_AttackVo.Set:speedRate(value)
	value = value > 0 and value or 1;
    if self._spdRate ~= value then
        self._spdRate = value;
        if self.skillEffData ~= nil and self.skillEffData.camActionId ~= nil and self.skillEffData.camActionId > 0 and self.bShowScreen then
            CameraActionController.instance:playSeries(self.skillEffData.camActionId, self._attackCountTime - self._countTime, self._spdRate);
        end
    end
end

function Lua_AttackVo.Get:speedRate()
	if self._spdRate == nil then
		local rvo = DataCenter.fightData:getRecordVoById(self.fightId);
		if rvo ~= nil then
			self._spd = rvo.speed;
			self._spdRate = rvo.speedRate;
		elseif self.attackPlayer ~= nil then
            self._spd = self.attackPlayer.data.aniSpeed;
            self._spdRate = self.attackPlayer.data.aniSpdRate;
        elseif self.targetPlayer ~= nil then
            self._spd = self.targetPlayer.data.aniSpeed;
            self._spdRate = self.targetPlayer.data.aniSpdRate;
        else
            self._spd = 1;
            self._spdRate = 1;
        end
	end
	return self._spdRate;
end

function Lua_AttackVo.Set:skillId(value)
	if self._skillId ~= value then
		self._skillId = value;
        self._skillConfigData = nil;
        self._skillEffData = nil;
	end
end

function Lua_AttackVo.Get:skillId()
	return self._skillId;
end

function Lua_AttackVo.Set:attackerId(value) --攻击者id
	if self._attackerId ~= value then
		self._attackerId = value;
        self._attackPlayer = nil;
	end
end

function Lua_AttackVo.Get:attackerId()
	return self._attackerId;
end

function Lua_AttackVo:addTargetId(secIdx, targetId, targetType)
    -- print("addTargetId", secIdx, targetId, targetType);
    self._minTargetsPos = nil;
    self._maxTargetsPos = nil;
    self._targetPlayer = nil;
    if self._maxSecIdx < secIdx then 
    	self._maxSecIdx = secIdx; 
    end
    if self._sectionTargetsDic == nil then
    	self._sectionTargetsDic = {}; 
    end
    local list = self._sectionTargetsDic[secIdx];
    if list == nil then
        list = Array();
        local info = Lua_AttackTargetInfo.new();
    	info.roleId = targetId; 
    	info.isTarget = targetType;
    	list:add(info);
        self._sectionTargetsDic[secIdx] = list;
    else
        local bHas = false;
        for i = 1, list:getSize() do
            if list[i].roleId == targetId and list[i].isTarget == targetType then
                bHas = true;
                break;
            end
        end

        if not bHas then 
        	local info = Lua_AttackTargetInfo.new();
        	info.roleId = targetId; 
        	info.isTarget = targetType;
        	list:add(info);
        end
    end    
    
    if targetType == 0 then
    	if self._targetHurtIds == nil then
    		self._targetHurtIds = Array();
    		self._targetHurtIds:add(targetId);
    		self._targetCount = self._targetCount + 1;
    		local tp = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, targetId);
            if tp ~= nil then tp.player:resetFlashCool(); end
    	elseif self._targetHurtIds:indexOf(targetId) == -1 then
    		self._targetHurtIds:add(targetId);
    		self._targetCount = self._targetCount + 1;
    		local tp = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, targetId);
            if tp ~= nil then tp.player:resetFlashCool(); end
    	end
    elseif targetType == 1 then
    	if self._targetIds == nil then
    		self._targetIds = Array();
    		self._targetIds:add(targetId);
    		self._targetCount = self._targetCount + 1;
    		local tp = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, targetId);
            if tp ~= nil then tp.player:resetFlashCool(); end
    	elseif self._targetIds:indexOf(targetId) == -1 then
    		self._targetIds:add(targetId);
    		self._targetCount = self._targetCount + 1;
    		local tp = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, targetId);
            if tp ~= nil then tp.player:resetFlashCool(); end
    	end
    end
end

function Lua_AttackVo.Get:targetCount()
	return self._targetCount;
end

function Lua_AttackVo:checkIsTarget(checkId, secIdx)
	if checkId == nil or checkId <= 0 then
		return false;
	end

	if secIdx ~= nil then
		if self._sectionTargetsDic ~= nil then
            local list = self._sectionTargetsDic[secIdx];
            if list ~= nil then
                for i = 1, list:getSize() do
                    if list[i].roleId == checkId then
                        return true;
                    end
                end
            end
        end
	elseif self._targetCount > 0 then
        if self._targetIds ~= nil and self._targetIds:indexOf(checkId) > 0 then
            return true;
        end
        if self._targetHurtIds ~= nil and self._targetHurtIds:indexOf(checkId) > 0 then
            return true;
        end
    end
    return false;
end

function Lua_AttackVo:getTargetMinPos()
	if self._sectionTargetsDic == nil then
		return nil;
	end
    
    local list = self._sectionTargetsDic[self._sectionIndex];
    if list == nil then
    	return nil;
    end

    local formationPos = nil;
    for i = 1, list:getSize() do
    	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[i].roleId);
    	if thing ~= nil and (formationPos == nil or thing.formationPos < formationPos) then
    		formationPos = thing.formationPos;
    		if formationPos <= 3 then -- 第一排无需再找
    			return formationPos;
    		end
    	end
    end
    return formationPos;
end

function Lua_AttackVo.Get:attackPlayer()
	if self._attackPlayer == nil then
		self._attackPlayer = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._attackerId);
	end
	return self._attackPlayer;
end

function Lua_AttackVo.Get:targetPlayer() -- 目标
    if self._targetPlayer == nil and self._sectionTargetsDic ~= nil then
        local list = self._sectionTargetsDic[self._sectionIndex];
        if list ~= nil then
            for i = 1, list:getSize() do
                if list[i].isTarget == 1 then
                    self._targetPlayer = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[i].roleId);
                    -- print("getThingPlayer", self.sceneId, self.fightId, list[i].roleId, self._targetPlayer == nil);
                    break;
                end
            end
            if self._targetPlayer == nil then
                self._targetPlayer = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[1].roleId);
            end
        end
    end
    return self._targetPlayer;
end

function Lua_AttackVo:addLuaCallBack(tb, attackedFun, completeFun, attackPointFun, shutteFun)
    self._table = tb;
    self._attackedEffCallBack = attackedFun;
    self._attackPointCallback = attackPointFun;
    self._completeCallBack = completeFun;
    self._shutterCallBack = shutteFun;
end

function Lua_AttackVo.Get:skillConfigData()
    if self._skillConfigData == nil then
        local fashionId = 0;
    	if self.attackPlayer ~= nil then
    		fashionId = self.attackPlayer.data.fashion_id;
    	end
        self._skillConfigData = Lua_SkillConfigData.getConfigData(self.skillId, fashionId);
    end
    return self._skillConfigData;
end

function Lua_AttackVo.Get:skillEffData()
    if self._skillEffData == nil and self.skillConfigData ~= nil then
        self._skillEffData = self.skillConfigData.skillEffCfgData;
    end
    return self._skillEffData;
end

function Lua_AttackVo:start()
    if self.skillConfigData == nil or self.skillEffData == nil then
    	self:completeSkillShow();
        return;
    end

    self._bDispose = false;
	self._playStep = 1;
	self._playActStep = 1;
	self._actAttackedStep = 1;
	self._hurtIdx = 1; --技能伤害索引
	self._preHurtIdx = 1; -- 技能伤害索引
	self._sectionIndex = 1; --技能伤害段数索引
	self._preSectionIndex = 1; -- 技能伤害段数索引
	self._effShowIdx = 1; -- 技能效果展示索引
	self._preEffShowIdx = 1; -- 技能效果展示索引
	self._playReleaseEffTime = 0;
	self._actDelayTime = 0;
	self._actAttackedTime = 0;
	self._actPlayTime = 0;
	self._effContactTime = 0;
	self._moveAdditionalTime = 0;
	self._playerMoveTime = 0;
	self._moveDelayTime = 0;
	self._moveStartTime = 0;
	self._bMoveToTarget = false;
	self._moveStartPosX = 0;
	self._moveStartPosY = 0;
	self._moveStartPosZ = 0;
	self._moveTargetPosX = 0;
	self._moveTargetPosY = 0;
	self._moveTargetPosZ = 0;
	self._bShowScreen = false;
	self.isTrunRound = false;
    self._targetPlayer = nil;

    local t, si, hi, ei = self.skillEffData:getHurtTimeByIdx(self._sectionIndex, self._hurtIdx, self._effShowIdx);
    if si ~= nil then self._sectionIndex = si; end
    if hi ~= nil then self._hurtIdx = hi; end
    if ei ~= nil then self._effShowIdx = ei; end
    self._hurtTime = t + self._moveAdditionalTime;

    t, si, hi, ei = self.skillEffData:getPreHurtValByIdx(self._preSectionIndex, self._preHurtIdx, self._preEffShowIdx);
    if si ~= nil then self._preSectionIndex = si; end
    if hi ~= nil then self._preHurtIdx = hi; end
    if ei ~= nil then self._preEffShowIdx = ei; end
    self._preHurtTime = t + self._moveAdditionalTime;

    self._countTime = self.skillEffData.countTime;
    if self.skillEffData.camActionId ~= nil and self.skillEffData.camActionId > 0 then
        local camActionTime = getConfig("tb_camera_action", self.skillEffData.camActionId, "countTime");
        if camActionTime ~= nil then
        	camActionTime = camActionTime / 30;
	        if self._countTime < camActionTime then
	            self._countTime = camActionTime;
	        end
	    end
    end

    self._lastTime = getTime();
    self._attackCountTime = self._countTime;
    self.bShowScreen = Scene3DManager.instance:isEnterScene(self.sceneId, self.fightId);
    -- print(self.bShowScreen, self._attackCountTime, self._countTime, self._preHurtTime, self._hurtTime, self._sectionIndex, self._hurtIdx, self._effShowIdx)
    Lua_CommonUtil.addTimer("playSkillFrameScript", 0.01, self, self.playSkillFrameScript);
    self:updateThingMaskAndShowState(true, false);
end

function Lua_AttackVo:updateThingMaskAndShowState(bMask, bShow, isForce)
	if self.skillEffData == nil then
		return;
	end

    if not self.bShowScreen and not isForce then
        return;
    end

    local isMaskOther = self.skillEffData.isMaskOther;
    local isHideOther = self.skillEffData.isHideOther;
    if not isMaskOther and not isHideOther then
        return;
    end

    if isMaskOther then
        Scene3DManager.instance:updateSceneMaskState(self.sceneId, self.fightId, bMask); -- 场景
    end

    local arr = DataCenter.thingData:getThingIds(self.sceneId, self.fightId);
    if arr ~= nil then
    	for i = 1, arr:getSize() do
    		local rid = arr[i];
    		if rid ~= self.attackerId
    			and (self._targetIds == nil or self._targetIds:indexOf(rid) == -1)
    			and (self._targetHurtIds == nil or self._targetHurtIds:indexOf(rid) == -1) then
	    		local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, rid);
	    		if thing ~= nil and thing.data ~= nil and not thing.data.isDead then
	    			if isMaskOther then 
	    				thing.player:updateSceneMaskState(bMask);
	    			end
	    			if isHideOther then
	    				thing.player:setActive(bShow);
	    			end
	    		end
	    	end
    	end
    end
end

function Lua_AttackVo:playSkillFrameScript()
    local t = getTime();
    local deltaTime = t - self._lastTime;
    deltaTime = deltaTime * self.speedRate;
    self._lastTime = t;

    self.bShowScreen = Scene3DManager.instance:isEnterScene(self.sceneId, self.fightId);
    self._countTime = self._countTime - deltaTime;
    if self._preHurtTime > 0 then
        self._preHurtTime = self._preHurtTime - deltaTime;
        if self._preHurtTime <= 0 then -- 触发
            if self._sectionTargetsDic ~= nil and self._sectionTargetsDic[self._preSectionIndex] ~= nil then
                self:showPreHurtEffects();
            end

           	self._preHurtIdx = self._preHurtIdx + 1;
           	local t, si, hi, ei = self.skillEffData:getPreHurtValByIdx(self._preSectionIndex, self._preHurtIdx, self._preEffShowIdx);
		    if si ~= nil then self._preSectionIndex = si; end
		    if hi ~= nil then self._preHurtIdx = hi; end
		    if ei ~= nil then self._preEffShowIdx = ei; end
		    t = t + self._moveAdditionalTime;
            if t > 0 then
                if t + self._preHurtTime < 0 then
                    self._preHurtTime = 0.01; -- 延后一帧触发下一次伤害
                else
                    self._preHurtTime = self._preHurtTime + t;
                end
            end
        end
    end

    if self._hurtTime > 0 then
        self._hurtTime = self._hurtTime - deltaTime;
        if self._hurtTime <= 0 then -- 触发伤害帧
        	if self._sectionTargetsDic ~= nil and self._sectionTargetsDic[self._sectionIndex] ~= nil then
                self:showAttacked();
                self:playHurtSound();
            end
            self:attackPointCallback();

            self._hurtIdx = self._hurtIdx + 1;
            local t, si, hi, ei = self.skillEffData:getHurtTimeByIdx(self._sectionIndex, self._hurtIdx, self._effShowIdx);
		    if hi ~= nil then self._hurtIdx = hi; end
		    if ei ~= nil then self._effShowIdx = ei; end
		    if si ~= nil and si ~= self._sectionIndex then 
		    	self._targetPlayer = nil; -- 重置目标
		    	self._sectionIndex = si; 
		    end
            if self._effContactTime > 0 and self.skillEffData:checkChangeHurtTimeByContact(self._sectionIndex, self._hurtIdx) then
				t = t + self._effContactTime;
			end
		    t = t + self._moveAdditionalTime;
            if t > 0 then
                if t + self._hurtTime < 0 then
                    self._hurtTime = 0.01; -- 延后一帧触发下一次伤害
                else
                    self._hurtTime = self._hurtTime + t;
                end
            end
        end
    end

    -- 溅射
    if self._shutterList ~= nil then
        local count = self._shutterList:getSize();
        while (count > 0) do
            local info = self._shutterList[count];
            if info:frameScript(deltaTime) then
                self._shutterList:remove(count);
                self:callShutterHurt(info.fromId, info.targetId, info.sectionIdx, info.hurtIdx);
                DataCenter.fightUtil:returnAttackShutterInfo(info);
            end
            count = count - 1;
        end
    end

    if self._playStep == 1 then -- 检测技能施法前表现
    	self:playReleaseEff(deltaTime);
    elseif self._playStep == 2 then -- 技能表现
    	self:playActionAndEffect(deltaTime);
    elseif self._playStep == 3 then --;
    	self:completeSkillShow();
    end
end

function Lua_AttackVo:playReleaseEff(dt)
    if self._playReleaseEffTime > 0 then
        self._playReleaseEffTime = self._playReleaseEffTime - dt;
        if self._playReleaseEffTime <= 0 then
            self._playStep = self._playStep + 1;
            self._playReleaseEffTime = 0;
            self:playSound();
        end
        return;
    end

    -- self:preLoadRes(); -- 预加载技能需要的资源
    local releaseEffStr = self.skillEffData.releaseEff;
    if strIsNullOrEmpty(releaseEffStr) then
        self._playStep = self._playStep + 1;
        self._playReleaseEffTime = 0;
        self:playSound();
        return;
    end

    self._playReleaseEffTime = self.skillEffData.releaseEffTime;
    if self._playReleaseEffTime <= 0 then
        self._playStep = self._playStep + 1;
        self._playReleaseEffTime = 0;
        self:playSound();
        return;
    end

    if self.bShowScreen then -- 显示
        local px = self.attackPlayer.data.px;
        local py = self.attackPlayer.data.py;
        local pz = self.attackPlayer.data.pz;
        self.effectManager:playActionEffect(self.sceneId, self.fightId, releaseEffStr, px, py, pz, nil, self.attackerId);
        if not strIsNullOrEmpty(skillEffData.releaseEffSound) then
            DataCenter.audioManager:play(skillEffData.releaseEffSound, self.fightId, self.speed, self.speedRate);
        end
    end
end

function Lua_AttackVo:playActionAndEffect(dt)
    if self.attackPlayer == nil then
        if self._playActStep == 1 then
            self:playSkillEffect();
            self._playActStep = self._playActStep + 1;
        end
        self:checkCompleteSkill();
        return;
    end

    -- 延迟动作
    if self._actDelayTime > 0 then
        self._actDelayTime = self._actDelayTime - dt;
        if self._actDelayTime <= 0 then
            self._actDelayTime = 0;
            self:initAttackerAction();
        end
    end

    -- 攻击点
    if self._actAttackedTime > 0 then -- 触发飞行特效
        self._actAttackedTime = self._actAttackedTime - dt;
        if self._actAttackedTime <= 0 then
            self:initActAttacked();
            self._actAttackedStep = self._actAttackedStep + 1;
            local t = self.skillEffData:getActAttackedTimeByIdx(self._playActStep, self._actAttackedStep);
            if t > 0 then
                if t + self._actAttackedTime < 0 then
                    self._actAttackedTime = 0.01; -- 延后一帧触发下一次伤害
                else
                    self._actAttackedTime = self._actAttackedTime + t;
                end
            end
            --print("_actAttackedTime = ", _actAttackedTime);
        end
    end

    -- 动作播放
    if self._actPlayTime > 0 then
        self._actPlayTime = self._actPlayTime - dt;
        if self._actPlayTime <= 0 then
            self._actPlayTime = 0;
            self:checkActComplete();
        end
    end

    if not self._bMoveToTarget and self._actPlayTime > 0 then
        return; -- 移动完成，动作未完成
    end

    if self._moveDelayTime > 0 then
        self._moveDelayTime = self._moveDelayTime - dt;
        if self._moveDelayTime > 0 then
            return;
        else
            dt = dt + self._moveDelayTime;
            self._moveDelayTime = 0;
        end
    end

    if not self._bMoveToTarget then
        if self._playActStep > self.skillEffData.actionsCount + 1 then
            self:checkCompleteSkill();
            return; -- 所有动作完成
        elseif self._playActStep == 1 then -- && string.IsNullOrEmpty(skillEffData.flyEff))
            self:checkUnitDir(1, -1); -- 非飞行特效朝向调整
        end

        self._bMoveToTarget = true;
        local px = self.attackPlayer.data.px;
        local py = self.attackPlayer.data.py;
        local pz = self.attackPlayer.data.pz;
        self._moveTargetPosX, self._moveTargetPosY, self._moveTargetPosZ = self:getCurActionTargetPos();
        if px == self._moveTargetPosX and py == self._moveTargetPosY and pz == self._moveTargetPosZ then -- 原地
            self:playActSound();
            self._moveStartTime = 0;
            self._playerMoveTime = 0;
            self._moveDelayTime = self.skillEffData:getMoveDelayByIdx(self._playActStep);
            local sec = self.skillEffData:getActTimeRelationHurtSecIdx(self._playActStep);
            if sec ~= nil and self._sectionTargetsDic ~= nil then
                if self._sectionTargetsDic[sec.hurtSec] ~= nil then
                    if self._attackCountTime ~= sec.countTime then
                        self._countTime = sec.countTime - (self._attackCountTime - self._countTime);
                        self._attackCountTime = sec.countTime;
                    end
                    self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
                    if self._actDelayTime <= 0 then 
                    	self:initAttackerAction(); 
                    end
                end
            else
                self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
                if self._actDelayTime <= 0 then 
                	self:initAttackerAction(); 
                end
            end

            if self._playActStep == 1 then
            	self:playSkillEffect();
            end
            self:moveComplete();
        else
            local st = 0;
            self._moveStartTime = 0;
            self._moveStartPosX = px;
            self._moveStartPosY = py;
            self._moveStartPosZ = pz;
            self._playerMoveTime = self.skillEffData:getActPosMoveTimeByIdx(self._playActStep);
            self._playerMoveTime = self._playerMoveTime < 0 and self.playerMoveToTargetTime or self._playerMoveTime;
            if self._playerMoveTime > 0 then
                local normalDis = self.skillEffData:getActPosMoveLenByIdx(self._playActStep);
                if normalDis > 0 then -- 根据移动距离动态调整
                    local dis = Vector3.DistanceTwoPoint(self._moveStartPosX, self._moveStartPosY, self._moveStartPosZ, self._moveTargetPosX, self._moveTargetPosY, self._moveTargetPosZ);
                    local mt = (self._playerMoveTime * dis) / normalDis;
                    st = (mt - self._playerMoveTime) * self.speedRate;
                    self._countTime = self._countTime + st;
                    if self._hurtTime > 0 then
                        self._hurtTime = self._hurtTime + st;
                        self._hurtTime = self._hurtTime <= 0 and 0.01 or self._hurtTime;
                    end
                    if self._actAttackedTime > 0 then
                        self._actAttackedTime = self._actAttackedTime + st;
                        self._actAttackedTime = self._actAttackedTime <= 0 and 0.01 or self._actAttackedTime;
                    end
                    if self._actPlayTime > 0 then
                        self._actPlayTime = self._actPlayTime + st;
                        self._actPlayTime = _actPlayTime <= 0 and 0.01 or self._actPlayTime;
                    end
                    if self.skillEffData.camActionId ~= nil and self.skillEffData.camActionId > 0 and self.bShowScreen then
                        CameraActionController.instance:playSeries(self.skillEffData.camActionId, self._attackCountTime - self._countTime, self.speedRate);
                    end
                    self._playerMoveTime = mt;
                    self._moveAdditionalTime = self._moveAdditionalTime + st;
                end
            end

            self._moveDelayTime = self.skillEffData:getMoveDelayByIdx(self._playActStep);
            if self.skillEffData:getActPosTypeByIdx(self._playActStep) == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_TARGETLINE then -- 朝向
                self.isTrunRound = true;
                self.attackPlayer.player.direction = MathUtil.getDirectionByXY(self._moveStartPosX, self._moveStartPosZ, self._moveTargetPosX, self._moveTargetPosZ);
            end

            if self.skillEffData:isMoveActByIdx(self._playActStep) then -- 移动和动作一起做
                self:playActSound();
                if self._playActStep == 1 then 
                	self:playSkillEffect(); 
                end
                local sec = self.skillEffData:getActTimeRelationHurtSecIdx(self._playActStep);
                if sec ~= nil and self._sectionTargetsDic ~= nil then
                	if self._sectionTargetsDic[sec.hurtSec] ~= nil then
	                    if self._attackCountTime ~= sec.countTime then
	                        self._countTime = sec.countTime - (self._attackCountTime - self._countTime);
	                        self._attackCountTime = sec.countTime;
	                    end
	                    self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
	                    if self._actDelayTime <= 0 then 
	                    	self:initAttackerAction(st); 
	                    end
	                end
                else
                	self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
	                if self._actDelayTime <= 0 then 
	                	self:initAttackerAction(st); 
	                end
                end
            end
        end
    else -- 移动
        local r = 1;
        if self._playerMoveTime > 0 then
            self._moveStartTime = self._moveStartTime + dt;
            r = self._moveStartTime / self._playerMoveTime;
        end
        
        if r >= 1 then
            self._moveStartTime = 0;
            self._playerMoveTime = 0;
            self.attackPlayer.player:setPosPoint(self._moveTargetPosX, self._moveTargetPosY, self._moveTargetPosZ, false);
            if not self.skillEffData:isMoveActByIdx(self._playActStep) then
                self:playActSound();
                if self._playActStep == 1 then 
                	self:playSkillEffect(); 
                end

                local sec = self.skillEffData:getActTimeRelationHurtSecIdx(self._playActStep);
                if sec ~= nil and self._sectionTargetsDic ~= nil then
                	if self._sectionTargetsDic[sec.hurtSec] ~= nil then
	                    if self._attackCountTime ~= sec.countTime then
	                        self._countTime = sec.countTime - (self._attackCountTime - self._countTime);
	                        self._attackCountTime = sec.countTime;
	                    end
	                    self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
	                    if self._actDelayTime <= 0 then 
	                    	self:initAttackerAction(); 
	                    end
	                end
                else
                	self._actDelayTime = self.skillEffData:getActDelayByIdx(self._playActStep);
	                if self._actDelayTime <= 0 then 
	                	self:initAttackerAction(); 
	                end
                end
            end

            self:moveComplete();
        else
        	local px = self._moveStartPosX + (self._moveTargetPosX - self._moveStartPosX) * r;
        	local py = self._moveStartPosY + (self._moveTargetPosY - self._moveStartPosY) * r;
        	local pz = self._moveStartPosZ + (self._moveTargetPosZ - self._moveStartPosZ) * r;
            self.attackPlayer.player:setPosPoint(px, py, pz, false);
        end
    end
end

function Lua_AttackVo:checkActComplete()
    if not self._bMoveToTarget and self._actPlayTime <= 0 then
        self._playActStep = self._playActStep + 1 ; -- 移动完成，动作表现完成
    end
end

function Lua_AttackVo:checkCompleteSkill()
    if self._bMoveToTarget then
        return;
    end

    if self._countTime > 0 
        or self._moveDelayTime > 0 
        or self._actDelayTime > 0 
        or self._actAttackedTime > 0 
        or self._actPlayTime > 0 then
        return;
    end

    if self._hurtTime > 0 and self._sectionIndex <= self._maxSecIdx then
        return;
    end

    if self._preHurtTime > 0 and self._preSectionIndex <= self._maxSecIdx then
        return;
    end

    if self._shutterList ~= nil and self._shutterList:getSize() > 0 then
        return;
    end

    self._playStep = self._playStep + 1;
end

function Lua_AttackVo:initAttackerAction(addTimeVal)
	if addTimeVal == nil then 
		addTimeVal = 0; 
	end

    self._actPlayTime = 0;
    self._actAttackedTime = 0;
    self._actAttackedStep = 1;
    local act = self.skillEffData:getActionByIdx(self._playActStep);
    if act > 0 then
        self._actAttackedTime = self.skillEffData:getActAttackedTimeByIdx(self._playActStep, self._actAttackedStep) + addTimeVal;
        self._actPlayTime = self.skillEffData:getActCountTimeByIdx(self._playActStep) + addTimeVal;
        if self._effContactTime > 0 and self.skillEffData:checkChangeActTimeByContact(self._playActStep) then 
        	self._actPlayTime = self._actPlayTime + self._effContactTime; 
        end
        -- print("initAttackerAction", act, self._actPlayTime, self._playerMoveTime, self._moveAdditionalTime, self._playActStep, self._actAttackedStep, nextAct, self._actAttackedTime);
        if self.bShowScreen and self.attackPlayer ~= nil then
            local bResetAct = self.skillEffData:getActResetStateByIdx(self._playActStep);
            -- print("initAttackerAction", self.skillId, self._playActStep, act, bResetAct, self.skillEffData.actionsCount);
            self.attackPlayer.player:forceUpdate(act, bResetAct, 1, Lua_ThingDefine.STAND, true, -1, 0, false);
        end
    end

    if self._actAttackedTime <= 0 and self._playActStep <= self.skillEffData.actionsCount then
        self:initActAttacked();
        self._actAttackedStep = self._actAttackedStep + 1;
    end
    if self._actPlayTime <= 0 then
        self:checkActComplete(); 
    end
end

function Lua_AttackVo:initActAttacked()
    if not self.bShowScreen or self.attackPlayer == nil then
        -- print("initActAttacked", self.bShowScreen, self.attackPlayer == nil)
        return;
    end

    self:playActAttackedSound();
    if self._sectionTargetsDic == nil then
        -- print("initActAttacked self._sectionTargetsDic == nil")
    	return;
    end

    local list = self._sectionTargetsDic[self._playActStep];
    if list == nil or list:getSize() <= 0 then
        -- print("initActAttacked list == nil")
    	return;
    end

    local effList = self.skillEffData:getActAttackedEffsList(self._playActStep, self._actAttackedStep);
    if effList == nil or #effList <= 0 then
        -- print("initActAttacked effList == nil")
        return;
    end

    local ax = self.attackPlayer.data.px;
    local ay = self.attackPlayer.data.py;
    local az = self.attackPlayer.data.pz;
    for i = 1, list:getSize() do
    	if list[i].isTarget == 1 then
	    	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[i].roleId);
	    	if thing ~= nil then
	    		local dir = MathUtil.getDirectionByXY(ax, az, thing.data.px, thing.data.pz);
	    		for j = 1, #effList do
	    			if not strIsNullOrEmpty(effList[j]) then
                        self.effectManager:playActionEffect(self._sceneId, self._fightId, effList[j], ax, ay, az, nil, self.attackerId, list[i].roleId, nil, nil, nil, dir);
	    			end
	    		end
	    	end
	    end
    end
end

function Lua_AttackVo:getCurActionTargetPos()
    local cfg = nil;
    local formationType;
    local tx = self.attackPlayer.data.px;
    local ty = self.attackPlayer.data.py;
    local tz = self.attackPlayer.data.pz;
    -- print("getCurActionTargetPos", self._playActStep, self.skillEffData.actionsCount, self.skillEffData.actPosTypeCount);
    if self.fightId > 0 and self._playActStep == self.skillEffData.actionsCount + 1 then -- 回合站位,播完所有动作后检测是否回到原地
        tx = self.attackPlayer.data.orginPosX;-- 回到起点
        ty = self.attackPlayer.data.orginPosY;
        tz = self.attackPlayer.data.orginPosZ;
    elseif self._playActStep <= self.skillEffData.actPosTypeCount then
        local posType = self.skillEffData:getActPosTypeByIdx(self._playActStep);
        -- print("getCurActionTargetPos", self.skillEffData.skillEffId, posType, self._playActStep, self.targetPlayer == nil, self.attackPlayer == nil);
        if posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_CENTER then -- 中心点
        	cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
        	if cfg == nil then
        		tx = DataCenter.fightUtil.fightStageCenter.x;
        		ty = DataCenter.fightUtil.fightStageCenter.y;
        		tz = DataCenter.fightUtil.fightStageCenter.z;
        	else
        		tx = cfg.stageCenterVecX;
        		ty = cfg.stageCenterVecY;
        		tz = cfg.stageCenterVecZ;
        	end
    	elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_TARGET then -- 目标正前
			if self.targetPlayer ~= nil then
                tx = self.targetPlayer.data.orginPosX;
                tz = self.targetPlayer.data.orginPosZ;
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_LINE then -- 目标列前
        	if self.targetPlayer ~= nil then
                cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
                if cfg ~= nil then
                    local vLineIdx = DataCenter.fightData:getVLineByPos(self.targetPlayer.formationPos);
                    -- print("getCurActionTargetPos 目标列前 vLineIdx", vLineIdx);
                    if vLineIdx ~= -1 then
                        local prePosByVLine = DataCenter.fightData:getPrePosByVLine(vLineIdx);
                        -- print("getCurActionTargetPos 目标列前 prePosByVLine", vLineIdx, prePosByVLine);
                        if prePosByVLine ~= -1 then
                            local pt = self.targetPlayer.formationType;
                        	tx = cfg:getPosxByIdx(pt, prePosByVLine);
                            tz = pt == Lua_FightDefine.FIGHT_ATTACKER and cfg.frontAttackerPosZ or cfg.frontDefenderPosZ;
                            -- print("getCurActionTargetPos 目标列前", vLineIdx, prePosByVLine, pt, tx, tz);
                        end
                    end
                end
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_TARGETLINE then --目标前（目标与自身方向）
        	if self.targetPlayer ~= nil then
                local vx = self.attackPlayer.data.orginPosX - self.targetPlayer.data.orginPosX;
                local vy = self.attackPlayer.data.orginPosY - self.targetPlayer.data.orginPosY;
                local vz = self.attackPlayer.data.orginPosZ - self.targetPlayer.data.orginPosZ;
                vx, vy, vz = Vector3.NormalizeVal(vx, vy, vz);
                local val = self.skillEffData:getActPosOffsetVDisByIdx(self._playActStep);
                tx = self.targetPlayer.data.orginPosX + vx * val;
                ty = self.targetPlayer.data.orginPosY + vy * val;
                tz = self.targetPlayer.data.orginPosZ + vz * val;
            end
            -- print("目标前（目标与自身方向）", tx, ty, tz, self.targetPlayer == nil, self._sectionIndex);
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_SELFCENTER then -- 己方阵型中心
        	cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
            if cfg ~= nil then
                if self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER then
                	local attackCenter = cfg.attackCenter;
                	tx = (attackCenter ~= nil and #attackCenter > 0) and attackCenter[1] or 0;
                	ty = (attackCenter ~= nil and #attackCenter > 1) and attackCenter[2] or 0;
                	tz = (attackCenter ~= nil and #attackCenter > 2) and attackCenter[3] or 0;
                else
                	local defendCenter = cfg.defendCenter;
                	tx = (defendCenter ~= nil and #defendCenter > 0) and defendCenter[1] or 0;
                	ty = (defendCenter ~= nil and #defendCenter > 1) and defendCenter[2] or 0;
                	tz = (defendCenter ~= nil and #defendCenter > 2) and defendCenter[3] or 0;
                end
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_TARGETCENTER then -- 对方阵型中心
        	formationType = -1;
            if self.targetPlayer ~= nil then
                formationType = self.targetPlayer.formationType;
                cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
            end
            if cfg == nil then
                formationType = self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER and Lua_FightDefine.FIGHT_DEFENDER or Lua_FightDefine.FIGHT_ATTACKER;
                cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
            end
            if cfg ~= nil then
            	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
                	local attackCenter = cfg.attackCenter;
                	tx = (attackCenter ~= nil and #attackCenter > 0) and attackCenter[1] or 0;
                	ty = (attackCenter ~= nil and #attackCenter > 1) and attackCenter[2] or 0;
                	tz = (attackCenter ~= nil and #attackCenter > 2) and attackCenter[3] or 0;
                else
                	local defendCenter = cfg.defendCenter;
                	tx = (defendCenter ~= nil and #defendCenter > 0) and defendCenter[1] or 0;
                	ty = (defendCenter ~= nil and #defendCenter > 1) and defendCenter[2] or 0;
                	tz = (defendCenter ~= nil and #defendCenter > 2) and defendCenter[3] or 0;
                end
            end
            -- print("初始阵型位置", tx, ty, tz, formationType, cfg == nil);
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_FRONTTARGET_CENTERLINE then -- 最前排目标行，中间列
        	formationType = -1;
            if self.targetPlayer ~= nil then
                formationType = self.targetPlayer.formationType;
                cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
            end
            if cfg == nil then
                formationType = self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER and Lua_FightDefine.FIGHT_DEFENDER or Lua_FightDefine.FIGHT_ATTACKER;
                cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
            end
            if cfg ~= nil then
                local formationPos = self:getTargetMinPos();
                -- print("formationPos", formationPos);
                if formationPos ~= nil then
                    local vec = cfg:getHMidPosByIdx(formationType, formationPos);
                    tx = vec.x;
                    ty = vec.y;
                    tz = vec.z;
                    -- print("最前排目标行，中间列", tx, ty, tz, formationType, cfg == nil);
                end
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_FRONTROW then -- 对方前排
    		formationType = -1;
            if self.targetPlayer ~= nil then
                formationType = self.targetPlayer.formationType;
                cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
            end
            if cfg == nil then
                formationType = self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER and Lua_FightDefine.FIGHT_DEFENDER or Lua_FightDefine.FIGHT_ATTACKER;
                cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
            end
            if cfg ~= nil then
                local formationPos = DataCenter.thingData:getFrontOrBackFormationPos(sceneId, fightId, formationType, false);
                if formationPos ~= nil then
                    local vec = cfg:getHMidPosByIdx(formationType, formationPos);
                    tx = vec.x;
                    ty = vec.y;
                    tz = vec.z;
                end
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_BACKROW then -- 对方后排
        	formationType = -1;
            if self.targetPlayer ~= nil then
                formationType = self.targetPlayer.formationType;
                cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
            end
            if cfg == nil then
                formationType = self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER and Lua_FightDefine.FIGHT_DEFENDER or Lua_FightDefine.FIGHT_ATTACKER;
                cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
            end
            if cfg ~= nil then
                local formationPos = DataCenter.thingData:getFrontOrBackFormationPos(sceneId, fightId, formationType, true);
                if formationPos ~= nil then
                    local vec = cfg:getHMidPosByIdx(formationType, formationPos);
                    tx = vec.x;
                    ty = vec.y;
                    tz = vec.z;
                end
            end
        elseif posType == Lua_FightDefine.FIGHTPLAY_SKILL_RELEASETYPE_ORGINPOS then -- 初始阵型位置
        	tx = self.attackPlayer.data.orginPosX; 
            ty = self.attackPlayer.data.orginPosY; 
            tz = self.attackPlayer.data.orginPosZ; 
            -- print("初始阵型位置", tx, ty, tz);
    	end

        local releaseOffsetX = self.skillEffData:getActPosOffsetXByIdx(self._playActStep);
        local releaseOffsetY = self.skillEffData:getActPosOffsetYByIdx(self._playActStep);
        local releaseOffsetZ = self.skillEffData:getActPosOffsetZByIdx(self._playActStep);
        if self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER then 
            releaseOffsetX = -releaseOffsetX;
            releaseOffsetZ = -releaseOffsetZ;
        end
        tx = tx + releaseOffsetX;
        ty = ty + releaseOffsetY;
        tz = tz + releaseOffsetZ;
    end
    return tx, ty, tz;
end

function Lua_AttackVo:moveComplete()
    if self._playActStep > self.skillEffData.actionsCount + 1 then -- 回到起点
        self._bMoveToTarget = false;
        return;
    end

    -- 位移到目的播放的特效
    local list = self.skillEffData:getMoveTargetActEffs(self._playActStep);
    if list ~= nil and #list > 0 then
    	local vx = self.attackPlayer.data.px;
    	local vy = self.attackPlayer.data.py;
    	local vz = self.attackPlayer.data.pz;
    	local targetId = self.targetPlayer ~= nil and self.targetPlayer.playerId or 0;
    	for i = 1, #list do
    		if not strIsNullOrEmpty(list[i]) then
    			local cfg = Lua_EffectConfigData.getConfigData(list[i]);
    			if cfg ~= nil then
    				local startPos = 0;
                    local endPos = 0;
                    if cfg.startType == 8 or cfg.startType == 9 then
                        startPos = self:getAllTargetsMinOrMaxPos(true);
                    end
                    if cfg.endType == 8 or cfg.endType == 9 then
                        endPos = self:getAllTargetsMinOrMaxPos(true);
                    end
                    self.effectManager:playActionEffect(self._sceneId, self._fightId, list[i], vx, vy, vz, nil, self.attackerId, targetId, nil, nil, nil, nil, startPos, endPos);
    			end
    		end
    	end
    end

    self._bMoveToTarget = false;
    self:checkActComplete();
end

function Lua_AttackVo:playSound()
	if not self.bShowScreen then return; end
	local list = self.skillEffData.skillSounds;
	if list ~= nil then
		for i = 1, #list do
			if not strIsNullOrEmpty(list[i]) then
				DataCenter.audioManager:play(list[i], self.fightId, self.speed, self.speedRate);
			end
		end
	end
end

function Lua_AttackVo:playActSound()
	if not self.bShowScreen then return; end
	local sound = self.skillEffData:getActSoundByIdx(self._playActStep);
	if not strIsNullOrEmpty(sound) then
		DataCenter.audioManager:play(sound, self.fightId, self.speed, self.speedRate);
	end
end

function Lua_AttackVo:playActAttackedSound()
	if not self.bShowScreen then return; end
	local sound = self.skillEffData:getActAttackedSoundByIdx(self._playActStep, self._actAttackedStep);
	if not strIsNullOrEmpty(sound) then
		DataCenter.audioManager:play(sound, self.fightId, self.speed, self.speedRate);
	end
end

function Lua_AttackVo:playHurtSound()
	if not self.bShowScreen then return; end
	local sound = self.skillEffData:getHurtSoundByIdx(self._effShowIdx);
	if not strIsNullOrEmpty(sound) then
		DataCenter.audioManager:play(sound, self.fightId, self.speed, self.speedRate);
	end
end

function Lua_AttackVo:playSkillEffect()
    if self.bShowScreen then
        self:playAttackEffect(); -- 播放攻击特效
        self:playTargetEffect(); -- 播放目标特效
        self:playEveryOtherEffect(); -- 播放对方特效
        self:playEveryOwnEffect(); -- 播放己方特效
    end
end

function Lua_AttackVo:playAttackEffect() -- 播放攻击特效
    if not self.bShowScreen or self.attackPlayer == nil then 
    	return;
    end

    local list = self.skillEffData.actEffect;
    if list ~= nil and #list > 0 then
        local maxTime = 0;
        local vx = self.attackPlayer.data.px;
        local vy = self.attackPlayer.data.py;
        local vz = self.attackPlayer.data.pz;
        local targetId = self.targetPlayer ~= nil and self.targetPlayer.playerId or 0;
        for i = 1, #list do
            if not strIsNullOrEmpty(list[i]) then
            	local cfg = Lua_EffectConfigData.getConfigData(list[i]);
    			if cfg ~= nil then
    				local startPos = 0;
                    local endPos = 0;
                    if cfg.startType == 8 or cfg.startType == 9 then
                        startPos = self:getAllTargetsMinOrMaxPos(true);
                    end
                    if cfg.endType == 8 or cfg.endType == 9 then
                        endPos = self:getAllTargetsMinOrMaxPos(true);
                    end

                    if cfg.isThroughAllEff or cfg.isContactTwoEff or cfg.isContactAllEff then -- 穿刺效果
                        self.effectManager:playActionEffect(self._sceneId, self._fightId, list[i], vx, vy, vz, nil, self.attackerId, nil, nil, self.speed, self.speedRate, nil, nil, nil, self._targetIds);
                        local t = cfg:getEffContactTime(self._targetIds:getSize());
                        if t > maxTime then  
                        	maxTime = t; 
                        end
                    else
                        self.effectManager:playActionEffect(self._sceneId, self._fightId, list[i], vx, vy, vz, nil, self.attackerId, targetId, nil, nil, nil, nil, startPos, endPos);
                    end
                    
    			end
            end
        end

        if maxTime > 0 then
            self._effContactTime = maxTime;
            if self._actPlayTime > 0 and self.skillEffData:checkChangeActTimeByContact(self._playActStep) then
                self._actPlayTime = self._actPlayTime + self._effContactTime;
            end
            if self._hurtTime > 0 and self.skillEffData:checkChangeHurtTimeByContact(self._sectionIndex, self._hurtIdx) then
                self._hurtTime = self._hurtTime + self._effContactTime;
            end
        end
    end
end

function Lua_AttackVo:playTargetEffect() -- 目标特效
    if not self.bShowScreen or self._targetIds == nil then
        return; 
    end

    local len = self._targetIds:getSize();
    if len <= 0 then
        return;
    end

    local list = self.skillEffData.targetEffect;
    if list ~= nil and #list > 0 then
        local px = self.attackPlayer ~= nil and self.attackPlayer.data.px or 0;
        local pz = self.attackPlayer ~= nil and self.attackPlayer.data.pz or 0;
        for i = 1, len do
            local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetIds[i]);
            if thing ~= nil then
                local vx = thing.data.px;
                local vy = thing.data.py;
                local vz = thing.data.pz;
                for j = 1, #list do
                    if not strIsNullOrEmpty(list[j]) then
                        local dir = self.attackPlayer ~= nil and MathUtil.getDirectionByXY(vx, vz, px, pz) and 0;
                        self.effectManager:playActionEffect(self._sceneId, self._fightId, list[j], vx, vy, vz, nil, thing.playerId, nil, nil, nil, nil, dir);
                    end
                end
            end
        end
    end
end

function Lua_AttackVo:playEveryOtherEffect() -- 对方所有播放特效
	if not self.bShowScreen then
        return; 
    end

    local list = self.skillEffData.everyOtherEffect;
    if list ~= nil and #list > 0 then
        local apList = DataCenter.thingData:getThingIds(self.sceneId, self.fightId);
        if apList == nil or apList:getSize() <= 0 then
            return;
        end

        local formationType = self.attackPlayer.formationType;
        for i = 1, apList:getSize() do
            local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, apList[i]);
            if thing ~= nil and thing.formationType ~= formationType and thing.player.activeSelf then
	            local kind = thing.kind;
	            if kind == AnKind.HERO or kind == AnKind.MONSTER then
	                local vx = thing.data.px;
	                local vy = thing.data.py;
	                local vz = thing.data.pz;
	                for j = 1, #list do
	                    if not strIsNullOrEmpty(list[j]) then
	                        self.effectManager:playActionEffect(self._sceneId, self._fightId, list[j], vx, vy, vz, nil, apList[i]);
	                    end
	                end
	            end
	        end
        end
    end
end

function Lua_AttackVo:playEveryOwnEffect() -- 己方所有播放特效
	if not self.bShowScreen then
        return; 
    end

    local list = self.skillEffData.everyOwnEffect;
    if list ~= nil and #list > 0 then
    	local apList = DataCenter.thingData:getThingIds(self.sceneId, self.fightId);
        if apList == nil or apList:getSize() <= 0 then
            return;
        end

    	local formationType = self.attackPlayer.formationType;
        for i = 1, apList:getSize() do
            local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, apList[i]);
            if thing ~= nil and thing.formationType == formationType and thing.player.activeSelf then
	            local kind = thing.kind;
	            if kind == AnKind.HERO or kind == AnKind.MONSTER then
	                local vx = thing.data.px;
	                local vy = thing.data.py;
	                local vz = thing.data.pz;
	                for j = 1, #list do
	                    if not strIsNullOrEmpty(list[j]) then
	                        self.effectManager:playActionEffect(self._sceneId, self._fightId, list[j], vx, vy, vz, nil, apList[i]);
	                    end
	                end
	            end
	        end
        end
    end
end

function Lua_AttackVo:attackPointCallback()
    if self._table ~= nil and self._attackPointCallback ~= nil then
        local bLast = self.skillEffData:isLastOfSectionAttacked(self._sectionIndex, self._hurtIdx);
        self._attackPointCallback(self._table, self._sectionIndex, self._hurtIdx, bLast);
    end
end

function Lua_AttackVo:showAttacked() 
    if self._sectionTargetsDic == nil then
        return;
    end

    -- 伤害刷新
    local list = self._sectionTargetsDic[self._sectionIndex];
    if list ~= nil then
    	for i = 1, list:getSize() do
    		self:showAttackedEffect(list[i].roleId, list[i].isTarget); -- 伤害点触发
    	end
    end

    if self.bShowScreen and (self.skillEffData.camActionId == nil or self.skillEffData.camActionId <= 0) then
        self:beginShake(self._effShowIdx);
    end
end

function Lua_AttackVo:showAttackedEffect(rid, isTarget) -- 触发伤害回调
    if self.bShowScreen and isTarget == 1 then
        self:showHitBack(rid, self._effShowIdx);
        local hurtStr = self.skillEffData:getHurtEffectByIdx(self._effShowIdx);
        if not strIsNullOrEmpty(hurtStr) then -- 受伤效果
            local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, rid);
            if thing == nil then
                LogManager.LogError("战斗" .. fightId .. "获取不到目标对象：" .. rid);
                return;
            end
            local vx = thing.data.px;
            local vy = thing.data.py;
            local vz = thing.data.pz;
            local dir = self.attackPlayer ~= nil and MathUtil.getDirectionByXY(self.attackPlayer.data.px, self.attackPlayer.data.pz, vx, vz) or 0;
            self.effectManager:playActionEffect(self._sceneId, self._fightId, hurtStr, vx, vy, vz, nil, rid, nil, nil, nil, nil, dir);
        end
    end

    if self._table ~= nil and self._attackedEffCallBack ~= nil then
    	self._attackedEffCallBack(self._table, rid, self._sectionIndex, self._hurtIdx, isTarget);
    end
end

function Lua_AttackVo:showPreHurtEffects()
	if not self.bShowScreen or self._sectionTargetsDic == nil then
        return; 
    end

    -- 伤害刷新
    local list = self._sectionTargetsDic[self._preSectionIndex];
    if list ~= nil and list:getSize() > 0 then
        local hurtStr = self.skillEffData:getPreHurtEffectByIdx(self._preEffShowIdx);
        if not strIsNullOrEmpty(hurtStr) then -- 受伤效果
            for i = 1, list:getSize() do
            	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[i].roleId);
            	if thing ~= nil then
            		local vx = thing.data.px;
            		local vy = thing.data.py;
            		local vz = thing.data.pz;
            		local dir = self.attackPlayer ~= nil and MathUtil.getDirectionByXY(self.attackPlayer.data.px, self.attackPlayer.data.pz, vx, vz) or 0;
	                self.effectManager:playActionEffect(self._sceneId, self._fightId, hurtStr, vx, vy, vz, nil, list[i].roleId, nil, nil, nil, nil, dir);
            	end
            end
        end
    end
end

function Lua_AttackVo:checkUnitDir(startIdx, endIdx) -- 转向
	if not self.bShowScreen or self._targetCount <= 0 then
        return; 
    end

    local turnType = self.skillEffData.turnType;
    if turnType == nil or turnType <= 0 then
    	return;
    end

    if turnType == 1 then -- 攻击者和被攻击者相向
    	self:attarkerTurnToTargetCenter(startIdx, endIdx);
        self:targetTurnToAttacker(startIdx, endIdx);
        self.isTrunRound = true;
    elseif turnType == 2 then -- 被攻击者转向攻击者
    	self:targetTurnToAttacker(startIdx, endIdx);
        self.isTrunRound = true;
    elseif turnType == 3 then -- 攻击者转向被攻击者阵型中心
    	self:attarkerTurnToCampCenter();
        self.isTrunRound = true;
    elseif turnType == 4 then -- 攻击者转向被攻击者范围中心
    	self:attarkerTurnToTargetCenter(startIdx, endIdx);
        self.isTrunRound = true;
    elseif turnType == 5 then -- 被攻击者转向攻击者，攻击者转向被攻击者阵型中心
    	self:attarkerTurnToCampCenter();
    	self:targetTurnToAttacker(startIdx, endIdx);
        self.isTrunRound = true;
    elseif turnType == 6 then -- 被攻击者转向攻击者，攻击者转向被攻击者范围中心
    	self:attarkerTurnToTargetCenter(startIdx, endIdx);
        self:targetTurnToAttacker(startIdx, endIdx);
        self.isTrunRound = true;
    elseif turnType == 7 then -- 攻击者转向被攻击者
    	self:attarkerTurnToTargetCenter(startIdx, endIdx);
        self.isTrunRound = true;
    end
end

function Lua_AttackVo:targetTurnToAttacker(startIdx, endIdx)
    if self.attackPlayer == nil or self._targetIds == nil or self._targetIds:getSize() <= 0 then 
        return; 
    end

    local px = self.attackPlayer.data.px;
    local pz = self.attackPlayer.data.pz;
    local count = self._targetIds:getSize();
    endIdx = endIdx < 0 and count or endIdx;
    for i = startIdx, endIdx do
    	if self._targetIds[i] ~= self._attackerId then
    		local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetIds[i])
    		if thing ~= nil and not thing.data.isDead then
    			thing.player.direction = MathUtil.getDirectionByXY(thing.data.px, thing.data.pz, px, pz);
    		end
    	end
    end
end

function Lua_AttackVo:attarkerTurnToCampCenter()
	if self.attackPlayer == nil then
		return;
	end

    local cfg = nil;
    local formationType = -1;
    if self.targetPlayer ~= nil then
        formationType = self.targetPlayer.formationType;
        cfg = Lua_FightCampPosConfig.getConfigData(self.targetPlayer.data.campPosId);
    end
    if cfg == nil then
        formationType = self.attackPlayer.formationType == Lua_FightDefine.FIGHT_ATTACKER and Lua_FightDefine.FIGHT_DEFENDER or Lua_FightDefine.FIGHT_ATTACKER;
        cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
    end
    if cfg ~= nil then
        local list = formationType == Lua_FightDefine.FIGHT_ATTACKER and cfg.attackCenter or cfg.defendCenter;
        if list ~= nil and #list > 0 then
	        local vx = list[1];
	        local vz = #list > 2 and list[3] or 0;
	        self.attackPlayer.direction = MathUtil.getDirectionByXY(self.attackPlayer.data.px, self.attackPlayer.data.pz, vx, vz);
	    end
    end
end

function Lua_AttackVo:attarkerTurnToTargetCenter(startIdx, endIdx)
    if self.attackPlayer == nil or self._targetIds == nil or self._targetIds:getSize() <= 0 then 
        return; 
    end

    local vx = 0;
    local vy = 0;
    local vz = 0;
    local count = self._targetIds:getSize();
    endIdx = endIdx < 0 and count or endIdx;
    for i = startIdx, endIdx do
    	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetIds[i]);
    	if thing ~= nil and not thing.data.isDead then
    		vx = vx + thing.data.px;
    		vy = vy + thing.data.py;
    		vz = vz + thing.data.pz;
    	end
    end

    vx = vx / count;
    vy = vy / count;
    vz = vz / count;
    if self.attackPlayer.data.px == vx and self.attackPlayer.data.py == vy and self.attackPlayer.data.pz == vz then
    	return;
    end
    self.attackPlayer.direction = MathUtil.getDirectionByXY(self.attackPlayer.data.px, self.attackPlayer.data.pz, vx, vz);
end

function Lua_AttackVo:showHitBack(targetId, idx)
    if self.skillEffData:isHitBackByIdx(idx) then
        local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, targetId);
        if thing ~= nil then
        	thing.player:Rush(-1, false);
        end
    end
end

function Lua_AttackVo:beginShake(idx)
    local shakeTime = self.skillEffData:getCamShakeTimeByIdx(idx) / self.speedRate;
    if shakeTime > 0 then
        local formationType = self.attackPlayer ~= nil and self.attackPlayer.formationType or 0;
        local flip = formationType == Lua_FightDefine.FIGHT_ATTACKER and 1 or -1;
        local h = self.skillEffData:getCamShakeGapLenByIdx(idx, 1) * flip;
        local v = self.skillEffData:getCamShakeGapLenByIdx(idx, 2) * flip;
        local shakeDelay = self.skillEffData:getCamShakeDelayByIdx(idx);
        ShakeUtil.instance:beginShake(shakeTime, shakeDelay, h, v);
    end
end

function Lua_AttackVo:completeSkillShow()
    if self.bShowScreen 
    	and self.skillEffData ~= nil
    	and self.skillEffData.camActionId ~= nil 
    	and self.skillEffData.camActionId > 0 then
        CameraActionController.instance:clean(self.skillEffData.camActionId);
    end
    
    self:resetDir();
    self:updateThingMaskAndShowState(false, true, true);
    if self._table ~= nil and self._completeCallBack ~= nil then
        self._completeCallBack(self._table);
    end

    self:clearLuaCallBack();
    self._playStep = 4;
end

function Lua_AttackVo:resetTargets()
    self._targetCount = 0;
    self._targetPlayer = nil;
    self._minTargetsPos = -1;
    self._maxTargetsPos = -1;
    if self._targetIds ~= nil then self._targetIds:clear(); end
    if self._targetHurtIds ~= nil then self._targetHurtIds:clear(); end
    if self._sectionTargetsDic ~= nil then table.clear(self._sectionTargetsDic); end
end

function Lua_AttackVo:resetDir()
    if not self.isTrunRound or self.skillEffData == nil then
    	return;
    end

    local cfg = nil
    local turnType = self.skillEffData.turnType;
    if self.attackPlayer ~= nil and turnType ~= 2 then
        cfg = Lua_FightCampPosConfig.getConfigData(self.attackPlayer.data.campPosId);
        if cfg ~= nil then
	        self.attackPlayer.player:setDir(cfg:getDirByType(self.attackPlayer.formationType), true);
	    end
    end

    if self._targetIds ~= nil and (turnType == 1 or turnType == 2 or turnType == 5 or turnType == 6) then
        for i = 1, self._targetIds:getSize() do
            local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetIds[i]);
            if thing ~= nil then
                if cfg == nil then
                	cfg = Lua_FightCampPosConfig.getConfigData(thing.data.campPosId);
                end
                if cfg == nil then
                	return;
                end
                thing.player:setDir(cfg:getDirByType(thing.formationType), true);
            end
        end
    end
end

function Lua_AttackVo:clearLuaCallBack()
	self._attackedEffCallBack = nil;
	self._attackPointCallback = nil;
	self._shutterCallBack = nil;
	self._table = nil;
end

function Lua_AttackVo:preLoadRes()
    -- 预加载技能需要的资源
    local configData;
    local proity = 999;
    local str = self.skillEffData.releaseEff;
    if not strIsNullOrEmpty(str) then
        configData = Lua_EffectConfigData.getConfigData(str)
        if configData ~= nil then
            LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
            proity = proity - 1;
        end
    end

    local list = self.skillEffData.actEffect;
    if list ~= nil and #list > 0 then
        for i = 1, #list do
            configData = Lua_EffectConfigData.getConfigData(list[i])
            if configData ~= nil then
                LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
                proity = proity - 1;
            end
        end
    end

    str = self.skillEffData.flyEff;
    if not strIsNullOrEmpty(str) then
        configData = Lua_EffectConfigData.getConfigData(str)
        if configData ~= nil then
            LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
            proity = proity - 1;
        end
    end

    list = self.skillEffData.targetEffect;
    if list ~= nil and #list > 0 then
        for i = 1, #list do
            configData = Lua_EffectConfigData.getConfigData(list[i])
            if configData ~= nil then
                LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
                proity = proity - 1;
            end
        end
    end

    list = self.skillEffData.everyOwnEffect;
    if list ~= nil and #list > 0 then
        for i = 1, #list do
            configData = Lua_EffectConfigData.getConfigData(list[i])
            if configData ~= nil then
                LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
                proity = proity - 1;
            end
        end
    end

    list = self.skillEffData.everyOtherEffect;
    if list ~= nil and #list > 0 then
        for i = 1, #list do
            configData = Lua_EffectConfigData.getConfigData(list[i])
            if configData ~= nil then
                LoadManager.getInstance():Load(Lua_LoadFileType.UNITY3D, configData.effectPath, nil, nil, nil, nil, proity, 60);
                proity = proity - 1;
            end
        end
    end
end

function Lua_AttackVo:showShutterHurtEff(fromId, rid, secIdx, idx)
    -- 显示溅射效果
    if self.bShowScreen then
        local list = self.skillEffData:getShutterEffectByIdx(self._effShowIdx);
        if list ~= nil and #list > 0 then -- 溅射效果
            local dir = 0;
            local ap = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, rid);
            local vx = ap.data.px;
            local vy = ap.data.py;
            local vz = ap.data.pz;
            local fp = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, fromId);
           	if fp ~= nil and ap ~= nil then
           		dir = MathUtil.getDirectionByXY(fp.data.px, fp.data.pz, vx, vz);
           	end
           	for i = 1, #list do
           		if not strIsNullOrEmpty(list[i]) then
           			self.effectManager:playActionEffect(self._sceneId, self._fightId, list[i], vx, vy, vz, nil, fromId, rid, nil, nil, nil, dir);
           		end
           	end
        end
    end

    local dt = self.skillEffData:getShutterDelayTimeByIdx(self._effShowIdx);
    if dt > 0 then
        if self._shutterList == nil then self._shutterList = Array(); end
        local info = DataCenter.fightUtil:createAttackShutterInfo();
        info.fromId = fromId;
        info.targetId = rid;
        info.hurtIdx = idx;
        info.sectionIdx = secIdx;
        info.delayTime = dt;
        self._shutterList:add(info);
        return false;
    end
    return true; -- 立马刷新伤害
end

function Lua_AttackVo:callShutterHurt(fromId, targetId, secIdx, idx)
    if self._table ~= nil and self._shutterCallBack ~= nil then
        self._shutterCallBack(self._table, fromId, targetId, secIdx, idx);
    end
end

function Lua_AttackVo:getAllTargetsMinOrMaxPos(isMin)
    if self._minTargetsPos == nil or self._maxTargetsPos == nil then
        self._minTargetsPos = 10;
        self._maxTargetsPos = 1;
        if self._targetIds ~= nil then
            for i = 1, self._targetIds:getSize() do
            	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetIds[i]);
            	if thing ~= nil then
                    if thing.formationPos < self._minTargetsPos then
                        self._minTargetsPos = thing.formationPos;
                    end
                    if thing.formationPos > self._maxTargetsPos then
                        self._maxTargetsPos = thing.formationPos;
                    end
                end
            end
        end

        if self._targetHurtIds ~= nil then
            for i = 1, self._targetHurtIds:getSize() do
            	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, self._targetHurtIds[i]);
            	if thing ~= nil then
                    if thing.formationPos < self._minTargetsPos then
                        self._minTargetsPos = thing.formationPos;
                    end
                    if thing.formationPos > self._maxTargetsPos then
                        self._maxTargetsPos = thing.formationPos;
                    end
                end
            end
        end
    end

    return isMin and self._minTargetsPos or self._maxTargetsPos;
end

function Lua_AttackVo:getTargetsMinOrMaxPos(secIdx, isMin)
    local formationPos = isMin and 10 or 1;
    if self._sectionTargetsDic ~= nil then
        local list = self._sectionTargetsDic[secIdx];
        if list ~= nil then
            for i = 1, list:getSize() do
            	local thing = DataCenter.thingData:getThingPlayer(self.sceneId, self.fightId, list[i]);
            	if thing ~= nil then
                    if isMin then
                    	if thing.formationPos < formationPos then
	                        formationPos = thing.formationPos;
	                    end
                    else
                    	if thing.formationPos > formationPos then
	                        formationPos = thing.formationPos;
	                    end
                    end
                end
            end
        end
    end
    return formationPos;
end