Lua_FirstRechargeConfigVo = class("Lua_FirstRechargeConfigVo")
function Lua_FirstRechargeConfigVo:ctor(id)
	self.id = id;
end

function Lua_FirstRechargeConfigVo:updateGradeInfo(msg)
	self._actDay = msg.activeted_day; -- 激活天数
	self._drawedCount = #msg.draw_list; -- 已领取数量
	self._isDrawedAllReward = self.drawedCount >= self.rewardCount;
end

function Lua_FirstRechargeConfigVo.Get:redPointState()
	if self.actDay > 0 then
		local state = false;
		if not self.isDrawedAllReward then
			if self.actReward then
				state = not DataCenter.firstRechargeData:getRewardDrawState(self.actReward);
			else
				if self.actDay > self.drawedCount then
					state = true;
				end
			end
		end
		return state;
	end
	return false;
end

function Lua_FirstRechargeConfigVo.Get:actDay()
	return self._actDay or 0;
end

function Lua_FirstRechargeConfigVo.Get:drawedCount()
	return self._drawedCount or 0;
end

function Lua_FirstRechargeConfigVo.Get:isDrawedAllReward()
	return self._isDrawedAllReward or false;
end










function Lua_FirstRechargeConfigVo.Get:config()
	if self._config == nil then
		self._config = getConfig("recharge_first_config", self.id);
	end
	return self._config;
end

-- 挡位
function Lua_FirstRechargeConfigVo.Get:grade()
	return self.config.grade;
end

-- 所需金额
function Lua_FirstRechargeConfigVo.Get:money()
	return self.config.money;
end

-- 最大奖励数量
function Lua_FirstRechargeConfigVo.Get:rewardCount()
	if self.actReward then
		return 1 + #self.dailyReward;
	end
	return #self.dailyReward;
end

function Lua_FirstRechargeConfigVo.Get:actReward()
	return self.config.act_reward;
end

function Lua_FirstRechargeConfigVo.Get:dailyReward()
	local dic = self.config.daily_reward or {};
	table.sort( dic, function(a, b) return a < b end );
	return dic;
end

-- UI版本
function Lua_FirstRechargeConfigVo.Get:version()
	return self.config.version;
end

-- 是否播放动画
function Lua_FirstRechargeConfigVo.Get:isPlayTween()
	return self.config.is_play == 1;
end

-- 是否循环播放
function Lua_FirstRechargeConfigVo.Get:isLoop()
	return self.config.is_loop == 1;
end

-- 描述图片
function Lua_FirstRechargeConfigVo.Get:desIcon()
	return self.config.des_icon;
end

-- 英雄ID
function Lua_FirstRechargeConfigVo.Get:heroIdList()
	return self.config.hero_id_list;
end

-- 英雄立绘路径
function Lua_FirstRechargeConfigVo.Get:heroUrl()
	return self.config.hero_url;
end

function Lua_FirstRechargeConfigVo:getTweenInfo(group)
	return self.config["move_group_"..group];
end

function Lua_FirstRechargeConfigVo:getShowHeroInfo(group, step, idx)
	local tweenInfo = self.config["move_group_"..group];
	if tweenInfo == nil then
		return nil;
	end
	local stepInfo = tweenInfo[step];
	if stepInfo == nil then
		return nil;
	end
	return stepInfo[idx];
end

-- 英雄立绘图片
function Lua_FirstRechargeConfigVo:getHeroImgInfo(group, step)
	local imgInfo = self.config.hero_img_list[group];
	if imgInfo == nil then
		return nil;
	end
	return imgInfo[step];
end

-- 英雄立绘位置
function Lua_FirstRechargeConfigVo:getHeroImgPosInfo(group, step)
	local imgPos = self.config.hero_img_pos_list[group];
	if imgPos == nil then
		return {0, 0};
	end
	return imgPos[step] or {0, 0};
end

-- 英雄信息图集
function Lua_FirstRechargeConfigVo.Get:atlas()
	return self.config.hero_info_atlas;
end

-- 英雄信息图片
function Lua_FirstRechargeConfigVo:getHeroDetailInfoSprite(group, step)
	local spriteInfo = self.config.hero_info_list[group];
	if spriteInfo == nil then
		return nil;
	end
	return spriteInfo[step];
end

-- 英雄信息位置
function Lua_FirstRechargeConfigVo:getHeroDetailPosInfo(group, step)
	local detailPos = self.config.hero_info_pos[group];
	if detailPos == nil then
		return {0, 0};
	end
	return detailPos[step] or {0, 0};
end

-- 英雄问号位置
function Lua_FirstRechargeConfigVo:getHeroReadPosInfo(group, step)
	local readPos = self.config.target_pos[group];
	if readPos == nil then
		return {0, 0};
	end
	return readPos[step] or {0, 0};
end