Lua_GashaponData = class("Lua_GashaponData");
function Lua_GashaponData:ctor()
	self:dispose();
end

function Lua_GashaponData:dispose()
	self._isDrawTween = nil;
	self._curDrawedTimes = nil;
	self.selectUpHeroInfo = nil; -- UP英雄
	self.upId = 0;
end

function Lua_GashaponData:fromServer50131018(msg)
	if msg == nil then
		return;
	end

	self.upId = msg.up_id; -- UP扭蛋ID
	self._diamondTimes = msg.diamond_time; -- 剩余钻石抽取次数
	self._curDrawedTimes = msg.luck_point; -- 幸运值（up已抽取次数）
	self.flag = msg.flag; -- 跳过动画标识 1跳过
	self:setUpheroInfo();
	self:updateMoreDrawRedDot();

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Recruit_Gashapon_UpHeroTips, msg.up_id == 0);
end

function Lua_GashaponData.Get:isDrawTween()
	return self._isDrawTween or false;
end

function Lua_GashaponData.Get:curDrawedTimes()
	return self._curDrawedTimes or 0;
end

function Lua_GashaponData.Set:isDrawTween(val)
	if self._isDrawTween ~= val then
		self._isDrawTween = val;
		if not val then
			DataCenter.popupWinManager:checkPopupWin();
		end
	end
end

function Lua_GashaponData.Get:diamondTimes()
	return self._diamondTimes or 0;
end

function Lua_GashaponData:setUpheroInfo()
	if self.upId ~= 0 then
		self.selectUpHeroInfo = DataCenter.gashaponUtil:getSingleUpHeroInfo(self.upId);
	end
end

function Lua_GashaponData:updateMoreDrawRedDot()
	local moreDrawInfo = DataCenter.gashaponUtil.itemMoreInfo;
	local hasCount = DataCenter.packData:getItemCountById(moreDrawInfo[1]);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Recruit_Gashapon_MoreDraw, hasCount >= moreDrawInfo[2]);
end

function Lua_GashaponData:getOneDrawInfo()
	local info = DataCenter.gashaponUtil.itemOneInfo;
	local hasCount = DataCenter.packData:getItemCountById(info[1]);
	if hasCount >= info[2] then
		return 1, info;
	else
		if self.diamondTimes >= 1 then
			info = DataCenter.gashaponUtil.diamondOneInfo;
			-- hasCount = DataCenter.packData:getItemCountById(info[1]);
			-- if hasCount >= info[2] then
				return 0, info;
			-- else
			-- 	return 2, DataCenter.gashaponUtil.itemOneInfo;
			-- end
		else
			return 2, DataCenter.gashaponUtil.itemOneInfo;
		end
	end
end

function Lua_GashaponData:getMoreDrawInfo()
	local info = DataCenter.gashaponUtil.itemMoreInfo;
	local hasCount = DataCenter.packData:getItemCountById(info[1]);
	if hasCount >= info[2] then
		return 1, info;
	else
		if self.diamondTimes >= DataCenter.gashaponUtil.drawMoreTimes then
			info = DataCenter.gashaponUtil.diamondMoreInfo;
			-- hasCount = DataCenter.packData:getItemCountById(info[1]);
			-- if hasCount >= info[2] then
				return 0, info;
			-- else
			-- 	return 2, DataCenter.gashaponUtil.itemMoreInfo;
			-- end
		else
			return 2, DataCenter.gashaponUtil.itemMoreInfo;
		end
	end
end