checkRequire("Lua_GashaponData");
checkRequire("Lua_GashaponUtil");
Lua_GashaponProxy = class("Lua_GashaponProxy");
function Lua_GashaponProxy:ctor()
	DataCenter.gashaponData = Lua_GashaponData.new();
	DataCenter.gashaponUtil = Lua_GashaponUtil.new();

	Lua_MsgUtil.addLuaMsg(50131018, self, self.rGashaponInfo); -- 请求扭蛋机界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50131020, self, self.rDrawGashaponReward); -- 请求扭蛋机界面信息（返回）

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateGashaponRedDot); -- 道具数量改变时更新红点
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateGashaponRedDot); -- 货币改变时更新红点
end

-- 请求扭蛋机界面信息
function Lua_GashaponProxy:sGashaponInfo()
	sendMsg(10131018);
end

-- 请求扭蛋机更换UP英雄
function Lua_GashaponProxy:sChangeGashaponUpHero(up_id)
	local cmd = ProtoPublic_pb.Proto10131019();
	cmd.up_id = up_id; -- UP扭蛋ID
	sendMsg(10131019, cmd);
end

-- 请求扭蛋机抽取
function Lua_GashaponProxy:sDrawGashaponReward(draw_type, times)
	local cmd = ProtoPublic_pb.Proto10131020();
	cmd.type = draw_type; -- 0钻石 1扭蛋道具
	cmd.times = times; -- 抽取次数
	sendMsg(10131020, cmd);
end

-- 请求更改扭蛋机跳过动画标识
function Lua_GashaponProxy:sChangeBoxFlag(flag)
	local cmd = ProtoPublic_pb.Proto10131021();
	cmd.flag = flag; -- 1跳过
	sendMsg(10131021, cmd);
end

-- 请求扭蛋机界面信息（返回）
function Lua_GashaponProxy:rGashaponInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131018();
		msg:ParseFromString(mp.data);
		DataCenter.gashaponData:fromServer50131018(msg);
		Lua_MsgUtil.callFunc("UPDATE_GASHAPON_INFO");
	end
end

-- 请求扭蛋机抽取（返回）
function Lua_GashaponProxy:rDrawGashaponReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131020();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("ON_PLAY_GASHAPON_TWEEN", msg.gashapon_info);
	end
end

function Lua_GashaponProxy:updateGashaponRedDot(dic)
	local diamondInfo = DataCenter.gashaponUtil.diamondMoreInfo;
	local itemInfo = DataCenter.gashaponUtil.itemMoreInfo;
	if DataCenter.funcOpenData:isOpened(10291) then
		if dic[diamondInfo[1]] or dic[itemInfo[1]] then
			Lua_MsgUtil.callFunc("UPDATE_GASHAPON_COST_INFO");
			if dic[itemInfo[1]] then
				DataCenter.gashaponData:updateMoreDrawRedDot();
			end
		end
	end
end