Lua_HeroFashionConfigData = class("Lua_HeroFashionConfigData")
Lua_HeroFashionConfigData.configDic = {};
function Lua_HeroFashionConfigData.getConfig(id)
	id = id ~= nil and tonumber(tostring(id)) or 0;
	if id == 0 then
		return nil;
	end

	if Lua_HeroFashionConfigData.configDic[id] == nil then
		local config = getConfig("hero_clothes", id);
		if config == nil then
			return nil;
		end
		Lua_HeroFashionConfigData.configDic[id] = Lua_HeroFashionConfigData.new(id, config);
	end
	return Lua_HeroFashionConfigData.configDic[id];
end

function Lua_HeroFashionConfigData:ctor(id, config)
	self:superCall("ctor");
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("hero_clothes", id);
	end
end

function Lua_HeroFashionConfigData.Get:name()
	return self.config.name;
end

function Lua_HeroFashionConfigData.Get:type()
	return self.config.type or 1;
end

function Lua_HeroFashionConfigData.Get:heroId()
	return self.config.hero_id or 0;
end

function Lua_HeroFashionConfigData.Get:activateItem()
	return self.config.activate_item or 0;
end

function Lua_HeroFashionConfigData.Get:itemSubType()
	return self.config.item_sub_type or 0;
end

function Lua_HeroFashionConfigData.Get:activatePath()
	return self.config.activate_path or 0;
end

function Lua_HeroFashionConfigData.Get:curProp()
	return self.config.prop;
end

function Lua_HeroFashionConfigData.Get:allProp()
	return self.config.all_hero_prop;
end

function Lua_HeroFashionConfigData.Get:skinPicUrl()
	if self._skinPicUrl == nil and self.skinPic then
		self._skinPicUrl = LanUtil.StringProfile("/images/hero_fashion/", self.skinPic);
	end
	return self._skinPicUrl;
end

function Lua_HeroFashionConfigData.Get:skinPic()
	return self.config.skin_pic;
end

function Lua_HeroFashionConfigData.Get:avatar_atlas_1()
    return self.config.avatar_atlas_1;
end

function Lua_HeroFashionConfigData.Get:avatar_sprite_1()
    return self.config.avatar_sprite_1;
end

function Lua_HeroFashionConfigData.Get:avatar_atlas_2()
    return self.config.avatar_atlas_2;
end

function Lua_HeroFashionConfigData.Get:avatar_sprite_2()
    return self.config.avatar_sprite_2;
end

function Lua_HeroFashionConfigData.Get:atlas()
    return self.config.atlas;
end

function Lua_HeroFashionConfigData.Get:sprite()
    return self.config.sprite;
end

function Lua_HeroFashionConfigData.Get:path()
	if self._path == nil and self.config.path then
		self._path = LanUtil.StringProfile("/images/hero_item/", self.config.path, ".png");
	end
	return self._path
end

function Lua_HeroFashionConfigData.Get:heroRolePath()
	if self._heroRolePath == nil and self.config.hero_role_path then
		self._heroRolePath = LanUtil.StringProfile("/images/hero_role/", self.config.hero_role_path, ".png");
	end
    return self._heroRolePath;
end

function Lua_HeroFashionConfigData.Get:floder()
	return self.config.floder or "/model/";
end

function Lua_HeroFashionConfigData.Get:jid()
	return self.config.jid;
end

function Lua_HeroFashionConfigData.Get:modelUrl()
	if self._modelUrl == nil then
		self._modelUrl = LanUtil.StringProfile(self.floder, self.jid);
	end
	return self._modelUrl;
end

function Lua_HeroFashionConfigData.Get:modelSrc()
	return self.config.modelSrc;
end

function Lua_HeroFashionConfigData.Get:uiSceneId()
	return self.config.uiSceneId;
end

function Lua_HeroFashionConfigData.Get:uiModelUrl()
	if self._uiModelUrl == nil then
		self._uiModelUrl = LanUtil.StringProfile(self.floder, self.uiModelSrc);
	end
	return self._uiModelUrl;
end

function Lua_HeroFashionConfigData.Get:uiModelSrc()
	return self.config.uiModelSrc;
end

function Lua_HeroFashionConfigData.Get:uiModelAvatarName()
	return self.config.uiModelAvatarName;
end

function Lua_HeroFashionConfigData.Get:uiModelCamController()
	return self.config.uiModelCamController;
end

function Lua_HeroFashionConfigData.Get:uiModelScale()
	return self.config.uiModelScale or 1;
end

function Lua_HeroFashionConfigData.Get:poseActEffs()
	return self.config.poseActEffs;
end

function Lua_HeroFashionConfigData.Get:activatePoseActEffs()
	return self.config.activatePoseActEffs;
end

function Lua_HeroFashionConfigData.Get:showActEffs()
    return self.config.showActEffs;
end

function Lua_HeroFashionConfigData.Get:uiShowAct()
    return self.config.uiShowAct or Lua_ThingDefine.UIWAIT;
end

function Lua_HeroFashionConfigData.Get:lineSound()
	return self.config.line_sound;
end

function Lua_HeroFashionConfigData.Get:bShowFur()
	return self.config.show_fur == 1;
end