Lua_MoneyData = class("Lua_MoneyData");
function Lua_MoneyData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_MoneyData:dispose()
    self.bInit = false;
    self.moneyDic = {};
end

function Lua_MoneyData:fromServer(list)
    if list == nil then
        return;
    end

    local id;
    local num;
    local count = 0;
    if self.changeNumDic == nil then
        self.changeNumDic = {};
    else
        for k, _ in pairs(self.changeNumDic) do
            self.changeNumDic[k] = nil;
        end
    end

    for i = 1, #list do
        id = tonumber(list[i].id);
        num = tonumber(list[i].amount);
        if self.moneyDic[id] == nil then
            count = count + 1;
            self.changeNumDic[id] = num;
        elseif self.moneyDic[id] ~= num then
            count = count + 1;
            self.changeNumDic[id] = num - self.moneyDic[id];
        end
        self.moneyDic[id] = num;
    end

    if self.bInit and count > 0 then
        Lua_MsgUtil.callFunc("MONEY_UPDATE", self.changeNumDic);
        if self.changeNumDic[Lua_ResourcesDefine.DIAMOND] ~= nil then -- 钻石变化
            DataCenter.gameReported:UpdatePlayerInfo(Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate);
        end
    end

    self.bInit = true;
    DataCenter.funcOpenData:initServerInfo();
end

function Lua_MoneyData:getMoney(id)
    id = tonumber(id);
    if self.moneyDic[id] == nil then
        return 0;
    end
    return self.moneyDic[id];
end

function Lua_MoneyData:isMoney(id)
    id = tonumber(id);
    return Lua_ResourcesData.getConfigDataById(id) ~= nil;
end

-- 货币类型，需要数量，是否显示飘字，是否显示获取途径，是否前往充值
function Lua_MoneyData:isMoneyEnough(id, needNum, showTips, showObtainPath, showGotoRecharge)
    local isEnough = self:getMoney(id) >= needNum;
    if isEnough == false then
        if showObtainPath == true and showGotoRecharge ~= true then
            DataCenter.packUtil:openPathWindow(id, false);
        end

        if showTips == true then
            OperateAlert.show(LanUtil.formateStr(300, Lua_ResourcesData.getConfigDataById(id).name));
        end

        if showGotoRecharge == true then
            if id == Lua_ResourcesDefine.DIAMOND then
                if Lua_PlatformUtil.IsBanShu() then
                    if not showTips then
                        OperateAlert.show(LanUtil.formateStr(300, Lua_ResourcesData.getConfigDataById(id).name));
                    end
                else
                    local tipsData = { des = LanUtil.getValue(130009), btnType = 1, owner = self, sureFun = self.onSureFun };
                    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
                end
            end
        end
    end
    return isEnough;
end

function Lua_MoneyData:onSureFun(go)
    DataCenter.funcPathUtil:gotoFunction(1024, true)
end