Lua_WeeklyGiftVo = class("Lua_WeeklyGiftVo")
function Lua_WeeklyGiftVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_WeeklyGiftVo:updateBuyTimes(times, openWeek, worldLv)
	self.curLimitTimes = times;
	self.openWeek = openWeek;
	self.worldLv = worldLv;
end

function Lua_WeeklyGiftVo.Get:isOpened()
	return self.weekCond and self.lvlCond and self.funcCond;
end

function Lua_WeeklyGiftVo.Get:weekCond()
	return self.openWeek >= self.open_week;
end

function Lua_WeeklyGiftVo.Get:lvlCond()
	return #self.world_level > 1 and self.world_level[1] <= self.worldLv and self.world_level[2] >= self.worldLv;
end

function Lua_WeeklyGiftVo.Get:funcCond()
	if self.func_id then
		return DataCenter.funcOpenData:isOpened(self.func_id);
	end
	return true;
end










function Lua_WeeklyGiftVo.Get:config()
	if self._config == nil then
		self._config = getConfig("week_gift", self.id);
	end
	return self._config;
end

-- 购买金额
function Lua_WeeklyGiftVo.Get:recharge()
	local recharge = 0;
	if self.config.recharge_type ~= 1 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
		if rechargeInfo then
			recharge = tonumber(rechargeInfo.money);
		end
	end
	return recharge;
end

-- 限制购买次数
function Lua_WeeklyGiftVo.Get:curLimitTimes()
	if self._curLimitTimes == nil then
		self._curLimitTimes = self.limit_times;
	end
	return self._curLimitTimes or 0;
end

function Lua_WeeklyGiftVo.Set:curLimitTimes(val)
	self._curLimitTimes = val;
end

-- 排序
function Lua_WeeklyGiftVo.Get:sort()
	return self.config.sort or 0;
end

-- 功能开启id
function Lua_WeeklyGiftVo.Get:func_id()
	return self.config.func_id;
end

-- 开服周数
function Lua_WeeklyGiftVo.Get:open_week()
	return self.config.open_week;
end

-- 世界等级区间
function Lua_WeeklyGiftVo.Get:world_level()
	return self.config.world_level;
end

-- 限购总次数
function Lua_WeeklyGiftVo.Get:limit_times()
	return self.config.limit_times;
end

-- 奖励
function Lua_WeeklyGiftVo.Get:reward()
	return self.config.reward;
end

-- 奖励icon
function Lua_WeeklyGiftVo.Get:reward_icon()
	return self.config.reward_icon;
end

-- 道具比列
function Lua_WeeklyGiftVo.Get:rate()
	return #self.reward < 4 and 0.5 or 0.4;
end