Lua_ShopData = class("Lua_ShopData");
Lua_ShopData.NORMAL_SHOP = 1;    -- 百货商店
Lua_ShopData.HERO_SHOP = 2;      -- 英雄商店
Lua_ShopData.TALENT_SHOP = 3;    -- 天赋商店
Lua_ShopData.SKIN_SHOP = 4;      -- 皮肤商店
Lua_ShopData.LEAGUE_SHOP = 5;    -- 联盟商店
Lua_ShopData.ARENA_SHOP = 6;     -- 竞技商店
Lua_ShopData.TREASURE_SHOP = 7;  -- 探宝商店
Lua_ShopData.WAR_SHOP = 8;       -- 远征商店
Lua_ShopData.PEAK_SHOP = 9;      -- 巅峰商店
Lua_ShopData.SPIRIT_SHOP = 11;   -- 精灵商店
Lua_ShopData.SEER_SHOP = 12;     -- 先知商店
Lua_ShopData.EQUIP_SHOP = 13;    -- 寂灭商店
Lua_ShopData.DOMAIN_SHOP = 14;   -- 神域商店
Lua_ShopData.HERO_SKIN_SHOP = 15;-- 英雄皮肤商店
function Lua_ShopData:ctor()
	self:dispose();
end

function Lua_ShopData:dispose()
	self.mainType = nil;
	self.subType = nil;
	self.shopType = nil;
end

function Lua_ShopData:fromServer50113001(msg)
	if msg == nil then
		return;
	end
	
	self.curShopType = msg.type; -- 商城类型
	self.itemList = msg.item_list; -- 商城道具列表
	self.segmentLv = msg.segment_lvl; -- 巅峰对决段位（巅峰商店）
	self.domainFloor = msg.domain_floor; -- 神域普通层数

	local shopTypeVo = DataCenter.shopUtil:getShopTypeVo(self.curShopType);
	if shopTypeVo ~= nil and shopTypeVo.model == 1 then
		local obj;
		for i = 1, #self.itemList do
			obj = self.itemList[i];
			DataCenter.shopUtil:updateShopItemInfo(self.curShopType, obj);
		end
	else
		DataCenter.shopUtil:updateShopTypeInfo(msg.type, msg.refresh);--商城刷新信息
	end
end

function Lua_ShopData:fromServer80113001(msg)
	if msg == nil then
		return;
	end
	if msg.refresh == 1 then
		DataCenter.shopUtil:resetBuyTime();
		Lua_MsgUtil.callFunc("REFRESH_SHOP_INFO");
	end
end

function Lua_ShopData:fromServer50113004(msg)
	if msg == nil then
		return;
	end
	DataCenter.shopUtil:updateShopTypeInfo(msg.shop_type, msg.refresh);--商城刷新信息
end

function Lua_ShopData:fromServer80113003(msg)
	local t;
	for i = 1, #msg.deserve_list do
		t = msg.deserve_list[i];
		DataCenter.redPointData:updateRedPointState("Shop_TipType" .. t, true);
	end
end

function Lua_ShopData:getCurShopItemList(shopType)
	local list = {};
	local shopTypeVo = DataCenter.shopUtil:getShopTypeVo(shopType);
	if shopTypeVo ~= nil then 
		if shopTypeVo.model == 1 then 
			list = DataCenter.shopUtil:getShopItemList(shopType);
		elseif shopTypeVo.model == 3 or shopTypeVo.model == 2 then
			local obj;
			local showDeserve = false;
			for i = 1, #self.itemList do
				obj = self.itemList[i];
				local vo = Lua_ShopItemVo.new(obj.id);
				vo:updateServerInfo(obj);
				list[i] = vo;

				if vo.isShowDeserve then
					showDeserve = vo.isShowDeserve;
				end
			end
			if shopTypeVo.shopType ~= Lua_ShopData.SPIRIT_SHOP then
				table.sort( list, function(a, b) return a.sortIndex < b.sortIndex; end);

				if showDeserve then
					DataCenter.redPointData:updateRedPointState("Shop_TipType" .. shopType, true);
				end
			end
		end
	end

	if shopType == Lua_ShopData.HERO_SKIN_SHOP then
		table.sort(list, function(a, b)
			local aSellOut = a.isSoldOut == true and 0 or 1;
			local bSellOut = b.isSoldOut == true and 0 or 1;
			local aSkinId = a.clothes_id;
			local bSkinId = b.clothes_id;
			local aSort = getConfig("hero_clothes", aSkinId, "skin_type") == 1 and 1 or 0;
			local bSort = getConfig("hero_clothes", bSkinId, "skin_type") == 1 and 1 or 0;

			local aPreView = a.make_type == 1 and 0 or 1;
			local bPreView = b.make_type == 1 and 0 or 1;
			if aPreView ~= bPreView then -- 敬请期待处于最末
				return aPreView > bPreView;
			else
				if aSellOut == bSellOut then
					if aSort == bSort then
						return a.sort < b.sort;
					end
					return aSort > bSort;
				else
					return aSellOut > bSellOut;
				end
			end
		end);
	end

	return list;
end



------------------------- 先知商店 ------------------------

function Lua_ShopData:getCurItemArrByCamp(campType)
	local arr = Array()
	local list;
	if self.curShopType == Lua_ShopData.SEER_SHOP then
		list = self:getCurShopItemList(self.curShopType);
	else
		list = DataCenter.shopUtil:getShopItemList(Lua_ShopData.SEER_SHOP);
	end
	for i = 1, #list do
		if curShopItemArr[i].hero_camp ~= nil then
			if campType == Lua_HeroUtil.All_TYPE or campType == curShopItemArr[i].hero_camp then
				arr:add(curShopItemArr[i]);
			end
		end
	end
	return arr;
end