Lua_ShopSubTypeVo = class("Lua_ShopSubTypeVo")
function Lua_ShopSubTypeVo:ctor(id, config)
    self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig("shop_sub_type", id);
    end
end

function Lua_ShopSubTypeVo.Get:bOpened()
    if self.childShop ~= nil then
        local vo;
        self.closefuncId = nil;
        for i = 1, #self.childShop do
            vo = DataCenter.shopUtil:getShopTypeVo(self.childShop[i]);
            if vo ~= nil and vo:checkOpened() == true then
                return true;
            end

            if self.closefuncId == nil then
                self.closefuncId = vo.funcId;
            end
        end
    end
    return false;
end

function Lua_ShopSubTypeVo:showFuncAdvance()
    if self.closefuncId ~= nil then
        DataCenter.funcOpenData:isOpened(self.closefuncId, true);
    end
end

function Lua_ShopSubTypeVo.Get:bCheckAlliance()
    if self.childShop ~= nil then
        for i = 1, #self.childShop do
            if self.childShop[i] == Lua_ShopData.LEAGUE_SHOP then
                return true;
            end
        end
    end
    return false;
end

function Lua_ShopSubTypeVo.Get:redDotIdArr()
    if self._redDotIdArr == nil then
        self._redDotIdArr = Array();
        if self.childShop ~= nil then
            local vo;
            for i = 1, #self.childShop do
                vo = DataCenter.shopUtil:getShopTypeVo(self.childShop[i]);
                if vo ~= nil and vo.red_point_id ~= nil then
                    self._redDotIdArr:add(vo.red_point_id);
                end
            end
        end
    end
    return self._redDotIdArr;
end

function Lua_ShopSubTypeVo.Get:redDotState()
    local state = false;
    for i = 1, self.redDotIdArr:getSize() do
        state = DataCenter.redPointData:getRedPointStateById(self.redDotIdArr[i]);
        if state then
            break;
        end
    end
    return state;
end

-------------------- 配置数据 --------------------

function Lua_ShopSubTypeVo.Get:name()
    return self.config.name;
end

function Lua_ShopSubTypeVo.Get:childShop()
    return self.config.child_shop;
end

function Lua_ShopSubTypeVo.Get:winBg()
    return self.config.win_bg;
end

function Lua_ShopSubTypeVo.Get:sortIdx()
    return self.config.sortIdx;
end