-- 特效数据
Lua_EffectConfigData = class("Lua_EffectConfigData");
function Lua_EffectConfigData.getConfigData(id)
	if id == nil then
		return nil;
	end
	
    if Lua_EffectConfigData.configsDic == nil then
        Lua_EffectConfigData.configsDic = {};
    end
    if Lua_EffectConfigData.configsDic[id] == nil then
    	local cfg = getConfig("tb_effect", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_EffectConfigData.configsDic[id] = Lua_EffectConfigData.new(id, cfg);
    end
    return Lua_EffectConfigData.configsDic[id];
end

function Lua_EffectConfigData.getAllEffConfig()
	if Lua_EffectConfigData.configArr == nil then
		Lua_EffectConfigData.configArr = Array();
		if Lua_EffectConfigData.configsDic == nil then
			Lua_EffectConfigData.configsDic = {};
		end

		local config = getConfig("tb_effect");
		for k, v in pairs(config) do
			local vo = Lua_EffectConfigData.configsDic[k];
			if vo == nil then
				vo = Lua_EffectConfigData.new(k, v);
				Lua_EffectConfigData.configsDic[k] = vo;
			end
			Lua_EffectConfigData.configArr:add(vo);
		end
	end
	return Lua_EffectConfigData.configArr;
end





function Lua_EffectConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.configId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig("tb_effect", id);
	end
end

function Lua_EffectConfigData.Get:name()
	if self.config.name == nil then
		return "";
	end
	return self.config.name;
end

function Lua_EffectConfigData.Get:floder()
	return self.config.floder;
end

function Lua_EffectConfigData.Get:path()
	return self.config.path;
end

function Lua_EffectConfigData.Get:url()
	if self.floder == nil or self.path == nil then
		return "";
	end
	return "/"..self.floder .. "/" .. self.path;
end

function Lua_EffectConfigData.Get:effectPath()
	if self._effectPath == nil then
		self._effectPath = UrlManager.ModelPath(self.path, "/" .. self.floder);
    end
    return self._effectPath;
end

function Lua_EffectConfigData.Get:modelName()
	return self.path;
end

function Lua_EffectConfigData.Get:modelName()
	return self.path;
end

function Lua_EffectConfigData.Get:startType()
	if self.config == nil or self.config.startType == nil then
		return 0;
	end
	return self.config.startType;
end

function Lua_EffectConfigData.Get:endType()
	if self.config == nil or self.config.endType == nil then
		return 0;
	end
	return self.config.endType;
end

function Lua_EffectConfigData.Get:isThroughAllEff() -- 特效穿透所有目标列表
    return self.startType == 10 and self.endType == 10;
end

function Lua_EffectConfigData.Get:isContactTwoEff() -- 包括自身 + 目标列表，按顺序两两按顺序作为起始点目标点播放特效，time固定
    return self.startType == 11 and self.endType == 11;
end

function Lua_EffectConfigData.Get:isContactAllEff() -- 包括自身 + 目标列表，按顺序两两按顺序作为起始点目标点播放连接特效，time根据顺序处理
    return self.startType == 12 and self.endType == 12;
end

function Lua_EffectConfigData.Get:moveTime()
	if self.config == nil or self.config.moveTime == nil then
		return 0;
	end
	return self.config.moveTime / 30;
end

function Lua_EffectConfigData.Get:seriesMoveTime()
	if self.config == nil or self.config.seriesMoveOverTime == nil then
		return 0;
	end
	return self.config.seriesMoveOverTime / 30;
end

function Lua_EffectConfigData:getEffContactTime(contactCount)
    if self.isContactAllEff or self.isThroughAllEff then
        return contactCount * (self.moveTime + self.seriesMoveTime);
    end
    return 0;
end

function Lua_EffectConfigData.Get:moveType()
	if self.config == nil or self.config.moveType == nil then
		return 0;
	end
	return self.config.moveType;
end

function Lua_EffectConfigData.Get:hang()
	if self.config == nil or self.config.hang == nil then
		return 0;
	end
	return self.config.hang;
end

function Lua_EffectConfigData.Get:controllNormalDis()
	if self.config == nil or self.config.controllNormalDis == nil then
		return 0;
	end
	return self.config.controllNormalDis / 100;
end

function Lua_EffectConfigData.Get:bControllFlicp()
	if self.config == nil or self.config.controllFlicp == nil then
		return false;
	end
	return self.config.controllFlicp == 1;
end

function Lua_EffectConfigData:getControllRange(orginPosx, orginPosy, orginPosz, targetPosx, targetPosy, targetPosz, formationType)
    if self._controllPosXRangeMin == nil then
        self._controllPosXRangeMin = 0;
        self._controllPosXRangeMax = 0;
        self._controllPosYRangeMin = 0;
        self._controllPosYRangeMax = 0;
        self._controllPosZRangeMin = 0;
		self._controllPosZRangeMax = 0;
        local controllPosRange = self.config.controllPosRange;
        if controllPosRange ~= nil and #controllPosRange > 0 then
	        local list = controllPosRange[1];
	        self._controllPosXRangeMin = (list ~= nil and #list > 0) and list[1] or 0;
	        self._controllPosXRangeMax = (list ~= nil and #list > 1) and list[2] or 0;
	    end
	    if controllPosRange ~= nil and #controllPosRange > 1 then
	        local list = controllPosRange[2];
	        self._controllPosYRangeMin = (list ~= nil and #list > 0) and list[1] or 0;
	        self._controllPosYRangeMax = (list ~= nil and #list > 1) and list[2] or 0;
	    end
	    if controllPosRange ~= nil and #controllPosRange > 2 then
	        local list = controllPosRange[2];
	        self._controllPosZRangeMin = (list ~= nil and #list > 0) and list[1] or 0;
	        self._controllPosZRangeMax = (list ~= nil and #list > 1) and list[2] or 0;
	    end
    end

    local vx = 0;
    local vy = 0;
    local vz = 0;
    if self.moveType == 2 then -- 贝塞尔曲线，【实际控制点 = 起始与终点中心点 + 控制点】；
    	if self._controllPosXRangeMin ~= self._controllPosXRangeMax then
            vx = Mathf.Random(self._controllPosXRangeMin, self._controllPosXRangeMax);
        else
            vx = self._controllPosXRangeMin;
        end
        if self._controllPosYRangeMin ~= self._controllPosYRangeMax then
            vy = Mathf.Random(self._controllPosYRangeMin, self._controllPosYRangeMax);
        else
            vy = self._controllPosYRangeMin;
        end
        if self._controllPosZRangeMin ~= self._controllPosZRangeMax then
            vz = Mathf.Random(self._controllPosZRangeMin, self._controllPosZRangeMax);
        else
            vz = self._controllPosZRangeMin;
        end
	elseif self.moveType == 3 then --贝塞尔曲线，终点在起点的左侧或正相对则【实际控制点 = 起始与终点中心点 - 控制点】；终点在起点右侧则【实际控制点 = 起始与终点中心点 + 控制点】
		if self._controllPosXRangeMin ~= self._controllPosXRangeMax then
            vx = -Mathf.Random(self._controllPosXRangeMin, self._controllPosXRangeMax);
        else
            vx = -self._controllPosXRangeMin;
        end
        if self._controllPosYRangeMin ~= self._controllPosYRangeMax then
            vy = Mathf.Random(self._controllPosYRangeMin, self._controllPosYRangeMax);
        else
            vy = self._controllPosYRangeMin;
        end
        if self._controllPosZRangeMin ~= self._controllPosZRangeMax then
            vz = Mathf.Random(self._controllPosZRangeMin, self._controllPosZRangeMax);
        else
            vz = self._controllPosZRangeMin;
        end
	end

    local rate = 1;
    if self.controllNormalDis > 0 then
        rate = Vector3.DistanceTwoPoint(orginPosx, orginPosy, orginPosz, targetPosx, targetPosy, targetPosz) / self.controllNormalDis;
    end

    if self.bControllFlicp then
        vx = vx * (formationType == Lua_FightDefine.FIGHT_ATTACKER and -1 or 1);
    end

    rate = rate / 100;
    vz = vz * (formationType == Lua_FightDefine.FIGHT_ATTACKER and 1 or -1);
    return vx * rate, vy * rate, vz * rate;
end

function Lua_EffectConfigData.Get:startOffset()
	if self._startOffsetVec == nil then
		local list = self.config.startOffset;
		local px = (list ~= nil and #list > 0) and list[1] or 0;
		local py = (list ~= nil and #list > 1) and list[2] or 0;
		local pz = (list ~= nil and #list > 2) and list[3] or 0;
		self._startOffsetVec = Vector3(px, py, pz);
	end
	return self._startOffsetVec;
end

function Lua_EffectConfigData.Get:endOffset()
	if self._endOffsetVec == nil then
		local list = self.config.endOffset;
		local px = (list ~= nil and #list > 0) and list[1] or 0;
		local py = (list ~= nil and #list > 1) and list[2] or 0;
		local pz = (list ~= nil and #list > 2) and list[3] or 0;
		self._endOffsetVec = Vector3(px, py, pz);
	end
	return self._endOffsetVec;
end

function Lua_EffectConfigData.Get:delayTime()
	if self.config == nil or self.config.delayTime == nil then
		return 0;
	end
	return self.config.delayTime / 30;
end

function Lua_EffectConfigData.Get:time()
	if self.config == nil or self.config.time == nil then
		return 0;
	end
	return self.config.time / 30;
end

function Lua_EffectConfigData.Get:hang()
	if self.config == nil or self.config.hang == nil then
		return 0;
	end
	return self.config.hang;
end

function Lua_EffectConfigData.Get:hangPath()
	if self.config == nil then
		return nil;
	end
	return self.config.hangPath;
end

function Lua_EffectConfigData.Get:roleHide()
	if self.config == nil or self.config.roleHide == nil then
		return 0;
	end
	return self.config.roleHide;
end

function Lua_EffectConfigData.Get:num()
	if self.config == nil or self.config.num == nil then
		return 0;
	end
	return self.config.num;
end

function Lua_EffectConfigData.Get:interval()
	if self.config == nil or self.config.interval == nil then
		return 0;
	end
	return self.config.interval / 30;
end

function Lua_EffectConfigData.Get:baseLen()
	if self.config == nil or self.config.baseLen == nil then
		return 0;
	end
	return self.config.baseLen / 100;
end

function Lua_EffectConfigData.Get:mirrorType()
	if self.config == nil or self.config.mirrorType == nil then
		return 0;
	end
	return self.config.mirrorType;
end

function Lua_EffectConfigData.Get:delayMoveTime()
	if self.config == nil or self.config.delayMoveTime == nil then
		return 0;
	end
	return self.config.delayMoveTime / 30;
end

function Lua_EffectConfigData.Get:startRange()
	if self.config == nil or self.config.startRange == nil then
		return 0;
	end
	return self.config.startRange;
end

function Lua_EffectConfigData.Get:endRange()
	if self.config == nil or self.config.endRange == nil then
		return 0;
	end
	return self.config.endRange;
end

function Lua_EffectConfigData.Get:hasCamera()
	if self.config == nil or self.config.hasCamera == nil then
		return false;
	end
	return self.config.hasCamera == 1;
end

function Lua_EffectConfigData.Get:effRot()
	if self._effRot == nil then
		local list = self.config.effRot;
		local px = (list ~= nil and #list > 0) and list[1] or 0;
		local py = (list ~= nil and #list > 1) and list[2] or 0;
		local pz = (list ~= nil and #list > 2) and list[3] or 0;
		self._effRot = Vector3(px, py, pz);
	end
	return self._effRot;
end