-- 技能表现
Lua_SkillEffectConfigData = class("Lua_SkillEffectConfigData");
function Lua_SkillEffectConfigData.getConfigData(id)
    if Lua_SkillEffectConfigData.configsDic == nil then
        Lua_SkillEffectConfigData.configsDic = {};
    end
    if Lua_SkillEffectConfigData.configsDic[id] == nil then
    	local cfg = getConfig("tb_skill_effect", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_SkillEffectConfigData.configsDic[id] = Lua_SkillEffectConfigData.new(id, cfg);
    end
    return Lua_SkillEffectConfigData.configsDic[id];
end

function Lua_SkillEffectConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.skillEffId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig("tb_skill_effect", id);
	end
end

function Lua_SkillEffectConfigData.Get:countTime()
	if self._countTime == nil then
		self._countTime = self.config.countTime / 30;
	end
	return self._countTime;
end

function Lua_SkillEffectConfigData.Get:hurtTimes()
	if self.config.hurtTime ~= nil then
		return #self.config.hurtTime;
	end
	return 0;
end

function Lua_SkillEffectConfigData.Get:atlas()
	return self.config.atlas;
end

function Lua_SkillEffectConfigData.Get:sprite()
	return self.config.sprite;
end

function Lua_SkillEffectConfigData.Get:unlock_level_list() --解锁等级
	return self.config.unlock_level_list;
end

function Lua_SkillEffectConfigData.Get:skill_tag() -- 技能标签
	return self.config.skill_tag;
end

function Lua_SkillEffectConfigData.Get:des() -- 技能描述
	if self.config == nil or self.config.des == nil then
		return "";
	end
	return self.config.des;
end

function Lua_SkillEffectConfigData.Get:des1() -- 技能描述
	if self.config == nil or self.config.des1 == nil then
		return "";
	end
	return self.config.des1;
end

function Lua_SkillEffectConfigData.Get:des2() -- 技能描述
	if self.config == nil or self.config.des2 == nil then
		return "";
	end
	return self.config.des2;
end

function Lua_SkillEffectConfigData.Get:des3() -- 技能描述
	if self.config == nil or self.config.des3 == nil then
		return "";
	end
	return self.config.des3;
end

function Lua_SkillEffectConfigData.Get:des4() -- 技能描述
	if self.config == nil or self.config.des4 == nil then
		return "";
	end
	return self.config.des4;
end

function Lua_SkillEffectConfigData.Get:des5() -- 技能描述
	if self.config == nil or self.config.des5 == nil then
		return "";
	end
	return self.config.des5;
end

function Lua_SkillEffectConfigData.Get:white_des() -- 技能描述（颜色值以功能为主）
	if self.config == nil or self.config.white_des == nil then
		return "";
	end
	return self.config.white_des;
end

function Lua_SkillEffectConfigData.Get:buff_list() -- buff效果
	return self.config.buff_list;
end

function Lua_SkillEffectConfigData.Get:bShowFlash()
	if self.config == nil or self.config.isFalsh == nil then
		return false;
	end
	return self.config.isFalsh == 1;
end

--稀有度（符石用）
function Lua_SkillEffectConfigData.Get:rarity()
	if self.config == nil or self.config.rarity == nil then
		return 0;
	end
	return self.config.rarity;
end

--评分（符石用）
function Lua_SkillEffectConfigData.Get:grade()
	if self.config == nil or self.config.grade == nil then
		return 0;
	end
	return self.config.grade;
end

-- 目标选择类型，搭配target字段一起使用
function Lua_SkillEffectConfigData.Get:targetType()
	if self.config == nil or self.config.targetType == nil then
		return nil;
	end
	
	if self._targetType == nil then
		self._targetType = {};
		local t = self.config.targetType;
		for i = 1, #t do
			local list = t[i];
			for j = 1, #list do
				local pos = list[j];
				if self._targetType[pos] == nil then
					self._targetType[pos] = {};
				end
				table.insert(self._targetType[pos], i);
			end
		end
	end
	return self._targetType;
end

function Lua_SkillEffectConfigData.Get:flyEff()
	if self.config == nil or self.config.flyEff == nil then
		return nil;
	end
	return self.config.flyEff;
end

function Lua_SkillEffectConfigData.Get:flyTogetherNum()
	if self.config == nil or self.config.flyTogetherNum == nil then
		return 0;
	end
	return self.config.flyTogetherNum;
end

function Lua_SkillEffectConfigData.Get:color()
    if self.config.color == nil then
        return 1;
    end
    return self.config.color;
end

function Lua_SkillEffectConfigData.Get:isCondition()
    if self.config.isCondition == nil then
        return 0;
    end
    return self.config.isCondition;
end

function Lua_SkillEffectConfigData.Get:connect_id()
    if self.config.connect_id == nil then
        return 0;
    end
    return self.config.connect_id;
end

function Lua_SkillEffectConfigData:getHurtTimeByIdx(sectionIdx, hurtIdx, index)
	if self.config == nil or self.config.hurtTime == nil then
		return 0, sectionIdx, hurtIdx, index;
	end

	local arr;
	if self._hurtTimeList == nil then
		local idx = 0;
		local lastTime = 0;
		self._hurtTimeList = Array();
		local hurtTime = self.config.hurtTime;
		for i = 1, #hurtTime do
			arr = self._hurtTimeList[i];
			if arr == nil then
				arr = Array();
				self._hurtTimeList:add(arr);
			end

			local list = hurtTime[i];
			for j = 1, #list do
				idx = idx + 1;
				local t = list[j] - lastTime;
				lastTime = list[j];
				arr:add({time = t/30, index = idx});
			end
		end
	end

	if sectionIdx > self._hurtTimeList:getSize() then
		return 0, sectionIdx, hurtIdx, index;
	end

	arr = self._hurtTimeList[sectionIdx];
	if arr:getSize() < hurtIdx then
		sectionIdx = sectionIdx + 1;
		if sectionIdx > self._hurtTimeList:getSize() then
			return 0, sectionIdx - 1, hurtIdx, index;
		end
		
		arr = self._hurtTimeList[sectionIdx];
		local info = arr[1];
		if info == nil then
			return 0, sectionIdx - 1, hurtIdx, index;
		end

		hurtIdx = 1;
		return info.time, sectionIdx, hurtIdx, info.index;
	else
		local info = arr[hurtIdx];
		return info.time, sectionIdx, hurtIdx, info.index;
	end
end

function Lua_SkillEffectConfigData:getPreHurtValByIdx(preSectionIdx, preHurtIdx, index)
    if self.config == nil or self.config.preShowHurtEffTime == nil then
		return 0, preSectionIdx, preHurtIdx, index;
	end

	local arr;
	if self._preHurtTimeList == nil then
		local idx = 0;
		local lastTime = 0;
		self._preHurtTimeList = Array();
		local preShowHurtEffTime = self.config.preShowHurtEffTime;
		for i = 1, #preShowHurtEffTime do
			arr = self._preHurtTimeList[i];
			if arr == nil then
				arr = Array();
				self._preHurtTimeList:add(arr);
			end

			local list = preShowHurtEffTime[i];
			for j = 1, #list do
				idx = idx + 1;
				local t = list[j] - lastTime;
				lastTime = list[j];
				arr:add({time = t/30, index = idx});
			end
		end
	end

	if preSectionIdx > self._preHurtTimeList:getSize() then
		return 0, preSectionIdx, preHurtIdx, index;
	end

	arr = self._preHurtTimeList[preSectionIdx];
	if arr:getSize() < preHurtIdx then
		preSectionIdx = preSectionIdx + 1;
		if preSectionIdx > self._preHurtTimeList:getSize() then
			return 0, preSectionIdx - 1, preHurtIdx, index;
		end
		
		arr = self._preHurtTimeList[preSectionIdx];
		local info = arr[1];
		if info == nil then
			return 0, preSectionIdx - 1, preHurtIdx, index;
		end
		
		preHurtIdx = 1;
		return info.time, preSectionIdx, preHurtIdx, info.index;
	else
		local info = arr[preHurtIdx];
		return info.time, preSectionIdx, preHurtIdx, info.index;
	end
end

function Lua_SkillEffectConfigData:checkChangeHurtTimeByContact(sectionIdx, hurtIdx)
	if self.config == nil and self.config.changeHurtTimeByContact == nil then
		return false;
	end

	if #self.config.changeHurtTimeByContact < sectionIdx then
		return false;
	end

	local arr = self.config.changeHurtTimeByContact[sectionIdx];
	if #arr < hurtIdx then
		return false;
	end
	return arr[hurtIdx] ~= 0;
end

function Lua_SkillEffectConfigData:getActAttackedTimeByIdx(idx, step)
    if self._actAttackedTimeList == nil then
        self._actAttackedTimeList = Array();
        if self.config ~= nil and self.config.attackedTime ~= nil then
        	local count = #self.config.attackedTime;
        	for i = 1, count do
        		local arr = Array();
        		self._actAttackedTimeList:add(arr);
        		local list = self.config.attackedTime[i];
        		for j = 1, #list do
        			if j == 1 then
        				if i == 1 then
        					local t = list[j] / 30;
        					arr:add(t);
        				else
        					local lastList = self.config.attackedTime[i - 1];
        					local t = (list[j] - lastList[#lastList]) / 30;
        					arr:add(t);
        				end
        			else
        				local t = (list[j] - list[j - 1]) / 30;
        				arr:add(t);
        			end
        		end
        	end
        end
    end

    if idx == nil or self._actAttackedTimeList:getSize() < idx then
        return 0;
    end
    if step == nil or self._actAttackedTimeList[idx]:getSize() < step then
        return 0;
    end
    return self._actAttackedTimeList[idx][step];
end

function Lua_SkillEffectConfigData.Get:actionsCount()
	return (self.config ~= nil and self.config.actions ~= nil) and #self.config.actions or 0;
end

function Lua_SkillEffectConfigData:getMoveDelayByIdx(idx)
	if self.config == nil or self.config.actPosMoveDelayTime == nil then
		return 0;
	end
	if #self.config.actPosMoveDelayTime < idx then
		return 0;
	end
	return self.config.actPosMoveDelayTime[idx] / 30;
end

function Lua_SkillEffectConfigData:getActTimeRelationHurtSecIdx(step)
    if self._actTimeRelationHurtSecList == nil then
        self._actTimeRelationHurtSecList = Array();
        if self.config ~= nil and self.config.actTimeRelationHurtSec ~= nil then
        	local list = self.config.actTimeRelationHurtSec;
        	for i = 1, #list do
        		local sec = {};
        		if #list[i] == 0 then
        			sec.countTime = self.countTime;
        			sec.hurtSec = list[i];
        		else
        			sec.hurtSec = list[i][1];
	                local val = list[i][2];
	                if val ~= nil and val > 0 then
	                	sec.countTime = val / 30;
	                else
	                	sec.countTime = self.countTime;
	                end
        		end
        		self._actTimeRelationHurtSecList:add(sec);
        	end
        end
    end
    return self._actTimeRelationHurtSecList:getSize() >= step and self._actTimeRelationHurtSecList[step] or nil;
end

function Lua_SkillEffectConfigData:getActDelayByIdx(idx)
	if self.config == nil or self.config.actDelay == nil then
		return 0;
	end
	return #self.config.actDelay >= idx and (self.config.actDelay[idx] / 30) or 0;
end

function Lua_SkillEffectConfigData:getActPosMoveTimeByIdx(idx)
	if self.config == nil or self.config.actPosMoveTime == nil then
		return 0;
	end
	local len = #self.config.actPosMoveTime;
	if len <= 0 then
		return 0;
	end
	if idx >= self.actionsCount then
		return self.config.actPosMoveTime[len] / 30;
	end
	return len >= idx and (self.config.actPosMoveTime[idx] / 30) or 0;
end

function Lua_SkillEffectConfigData:getActPosMoveLenByIdx(idx)
    if self.config == nil or self.config.actPosMoveLen == nil then
    	return 0;
    end
    return #self.config.actPosMoveLen >= idx and self.config.actPosMoveLen[idx] or 0;
end

function Lua_SkillEffectConfigData:getActPosTypeByIdx(idx)
	if self.config == nil or self.config.actPosType == nil then
    	return 0;
    end
    return #self.config.actPosType >= idx and self.config.actPosType[idx] or 0;
end

function Lua_SkillEffectConfigData:isMoveActByIdx(idx)
	if self.config == nil or self.config.actMoveState == nil then
    	return false;
    end
    return #self.config.actMoveState >= idx and (self.config.actMoveState[idx] == 1) or false;
end

function Lua_SkillEffectConfigData:getActionByIdx(idx)
	if self.config == nil or self.config.actions == nil then
    	return 0;
    end
    return #self.config.actions >= idx and self.config.actions[idx] or 0;
end

function Lua_SkillEffectConfigData:getActCountTimeByIdx(idx)
	if self.config == nil or self.config.actTime == nil then
    	return 0;
    end
    return #self.config.actTime >= idx and (self.config.actTime[idx] / 30) or 0;
end

function Lua_SkillEffectConfigData:checkChangeActTimeByContact(step)
	if self.config == nil or self.config.changeActTimeByContact == nil then
    	return false;
    end
    return #self.config.changeActTimeByContact >= step and (self.config.changeActTimeByContact[step] ~= 0) or false;
end

function Lua_SkillEffectConfigData:getActResetStateByIdx(idx)
	if self.config == nil or self.config.actReset == nil then
    	return false;
    end
    if idx <= #self.config.actReset then
    	return self.config.actReset[idx] > 0;
    end
    return true;
end

function Lua_SkillEffectConfigData:getActAttackedEffsList(actIdx, attackedIdx)
	-- print("getActAttackedEffsList", self.skillEffId, actIdx, attackedIdx, self.config.actAttackedEffs ~= nil and #self.config.actAttackedEffs or 0);
	if self.config == nil or self.config.actAttackedEffs == nil then
    	return nil;
    end
    if #self.config.actAttackedEffs < actIdx then
    	return nil;
    end
    local list = self.config.actAttackedEffs[actIdx];
    if #list < attackedIdx then
    	return nil;
    end
    return list[attackedIdx];
end

function Lua_SkillEffectConfigData.Get:actPosTypeCount()
	if self.config == nil or self.config.actPosType == nil then
    	return 0;
    end
    return #self.config.actPosType;
end

function Lua_SkillEffectConfigData:getActPosOffsetVDisByIdx(idx)
	if self.config == nil or self.config.actPosOffsetVDis == nil or #self.config.actPosOffsetVDis < idx then
    	return Lua_CommonUtil.getCommonConfig("fight_faceTarget_distance", 1, 0);
    end
    return self.config.actPosOffsetVDis[idx];
end

function Lua_SkillEffectConfigData:getActPosOffsetXByIdx(idx)
	if self.config == nil or self.config.actPosOffsetX == nil then
    	return 0;
    end
    return #self.config.actPosOffsetX >= idx and self.config.actPosOffsetX[idx] or 0;
end
    
function Lua_SkillEffectConfigData:getActPosOffsetYByIdx(idx)
	if self.config == nil or self.config.actPosOffsetY == nil then
    	return 0;
    end
    return #self.config.actPosOffsetY >= idx and self.config.actPosOffsetY[idx] or 0;
end

function Lua_SkillEffectConfigData:getActPosOffsetZByIdx(idx)
	if self.config == nil or self.config.actPosOffsetZ == nil then
    	return 0;
    end
    return #self.config.actPosOffsetZ >= idx and self.config.actPosOffsetZ[idx] or 0;
end

function Lua_SkillEffectConfigData:getMoveTargetActEffs(actStep)
	if self.config == nil or self.config.moveTargetActEffs == nil then
    	return nil;
    end
    return self.config.moveTargetActEffs[actStep];
end

function Lua_SkillEffectConfigData.Get:skillSounds()
	if self.config == nil then
    	return nil;
    end
    return self.config.sound;
end

function Lua_SkillEffectConfigData:getActSoundByIdx(idx)
	if self.config == nil or self.config.actSound == nil then
    	return nil;
    end
    return self.config.actSound[idx];
end

function Lua_SkillEffectConfigData:getHurtSoundByIdx(idx)
	if self.config == nil or self.config.hurtSound == nil then
    	return nil;
    end
    return self.config.hurtSound[idx];
end

function Lua_SkillEffectConfigData:getActAttackedSoundByIdx(idx, step)
	if self.config == nil or self.config.actAttackedSound == nil then
		return nil;
	end
	if #self.config.actAttackedSound < idx then
		return nil;
	end
	return self.config.actAttackedSound[idx][step];
end

function Lua_SkillEffectConfigData.Get:actEffect()
	if self.config == nil then
    	return nil;
    end
    return self.config.actEffect;
end

function Lua_SkillEffectConfigData.Get:targetEffect()
	if self.config == nil then
    	return nil;
    end
    return self.config.targetEffect;
end

function Lua_SkillEffectConfigData.Get:everyOtherEffect()
	if self.config == nil then
    	return nil;
    end
    return self.config.everyOtherEffect;
end

function Lua_SkillEffectConfigData.Get:everyOwnEffect()
	if self.config == nil then
    	return nil;
    end
    return self.config.everyOwnEffect;
end

function Lua_SkillEffectConfigData:isLastOfSectionAttacked(sectionIdx, hurtIdx)
	if self.config == nil or self.config.hurtTime == nil then
		return true;
	end
	if sectionIdx > #self.config.hurtTime then
		return true;
	end
	if hurtIdx >= #self.config.hurtTime[sectionIdx] then
		return true;
	end
	return false;
end

function Lua_SkillEffectConfigData:getHurtEffectByIdx(idx)
	if self.config == nil or self.config.hurtEffect == nil then
		return nil;
	end
	return self.config.hurtEffect[idx];
end

function Lua_SkillEffectConfigData:getPreHurtEffectByIdx(idx)
	if self.config == nil or self.config.preHurtEff == nil then
		return nil;
	end
	return self.config.preHurtEff[idx];
end

function Lua_SkillEffectConfigData.Get:turnType()
	if self.config == nil then
		return nil;
	end
	return self.config.turn_type;
end

function Lua_SkillEffectConfigData:isHitBackByIdx(idx)
	if self.config == nil or self.config.hitBack == nil then
		return nil;
	end
	return #self.config.hitBack >= idx and (self.config.hitBack[idx] == 1) or false;
end

function Lua_SkillEffectConfigData:getCamShakeTimeByIdx(idx)
	if self.config == nil or self.config.camShakeTime == nil then
		return 0;
	end
	return #self.config.camShakeTime >= idx and self.config.camShakeTime[idx]/30 or 0;
end

function Lua_SkillEffectConfigData:getCamShakeGapLenByIdx(idx, step)
	if self.config == nil or self.config.shakeGapLen == nil then
		return 0;
	end
	if #self.config.shakeGapLen < idx then
		return 0;
	end
	if #self.config.shakeGapLen[idx] < step then
		return 0;
	end
	return self.config.shakeGapLen[idx][step] / 100;
end

function Lua_SkillEffectConfigData:getCamShakeDelayByIdx(idx)
	if self.config == nil or self.config.camShakeDelay == nil then
		return 0;
	end
	return #self.config.camShakeDelay >= idx and self.config.camShakeDelay[idx] or 0;
end

function Lua_SkillEffectConfigData.Get:camActionId()
	return self.config.camActionId;
end

function Lua_SkillEffectConfigData:getShutterEffectByIdx(idx)
	if self.config == nil or self.config.shutterEffect == nil then
		return nil;
	end
	return self.config.shutterEffect[idx];
end

function Lua_SkillEffectConfigData:getShutterDelayTimeByIdx(idx)
	if self.config == nil or self.config.shutterDelayTime == nil and #self.config.shutterDelayTime >= idx then
		return 0;
	end
	return self.config.shutterDelayTime[idx] / 30;
end

function Lua_SkillEffectConfigData.Get:isMaskOther()
	if self.config == nil or self.config.isMaskOther == nil then
		return false;
	end
	return self.config.isMaskOther == 1;
end

function Lua_SkillEffectConfigData.Get:isHideOther()
	if self.config == nil or self.config.isHideOther == nil then
		return false;
	end
	return self.config.isHideOther == 1;
end