Lua_StarTrialData = class("Lua_StarTrialData");
function Lua_StarTrialData:ctor()
	self:dispose();
end

function Lua_StarTrialData:dispose()
	self.curChapter = nil;
	self.refreshCond = nil;
	self.autoRefresh = false;
end

function Lua_StarTrialData:fromServer50194001(msg)
	if msg == nil then
		return;
	end

	if self.curChapter and self.curChapter ~= msg.cur_chapter then
		self.refreshCond = msg.cur_chapter;
	end
	if self.refreshCond and self.refreshCond == msg.chapter_info.chapter then
		self.refreshCond = nil;
		self.autoRefresh = true;
	end

	self.curShowChapter = msg.chapter_info.chapter; -- 当前显示的章节信息
	self.curChapter = msg.cur_chapter; -- 当前解锁的最新章节
	self.remainTime = msg.challenge_times; -- 剩余首通次数
	self.totalStar = msg.total_star; -- 所有章节获得的总星数
	
	local vo = DataCenter.starTrialUitl:getChapterVo(msg.chapter_info.chapter);
	vo:updateStarTrialChapterVoInfo(msg.chapter_info);

	self:updateSweepState(msg.day_reward);
	self:updateLevelRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_INFO");
end

function Lua_StarTrialData:fromServer50194002(msg)
	if msg == nil then
		return;
	end

	local vo = DataCenter.starTrialUitl:getChapterVo(msg.chapter);
	vo:updateStarRewardState(msg.reward);

	self:updateLevelRedPoint();
	self:updateChapterRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_STARREWARD");
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_INFO");
end

function Lua_StarTrialData:updateSweepState(data)
	if data == nil then
		return;
	end

	self.curSweepId = tonumber(tostring(data[1].key));
	self.sweepTimes = tonumber(tostring(data[1].value));
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StarTrial_Daily, self.sweepTimes > 0);
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_DAILYREWARD");
end

function Lua_StarTrialData:fromServer50194005(msg)
	if msg == nil then
		return;
	end
	-- 没解锁的章节不发
	table.sort( msg.chapter_state, function(a, b) return a.key < b.key end );
	table.sort( msg.reward_state, function(a, b) return a.type < b.type end );

	local vo;
	for i = 1, #msg.chapter_state do
		vo = DataCenter.starTrialUitl:getChapterVo(msg.chapter_state[i].key);
		vo.state = 1;
		vo.starNum = msg.chapter_state[i].value;
		vo:updateStarRewardState(msg.reward_state[i].map_list);
	end
	self:updateChapterRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_INFO");
end

function Lua_StarTrialData:updateLevelRedPoint()
	local vo = DataCenter.starTrialUitl:getChapterVo(self.curShowChapter)
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StarTrial_Level, vo.canDraw);
end

function Lua_StarTrialData:updateChapterRedPoint()
	local state = false;
	local chapterArr = DataCenter.starTrialUitl.getChapterArr;
	for i = 1, chapterArr:getSize() do
		if chapterArr[i].canDraw then
			state = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StarTrial_Chapter, state);
end

function Lua_StarTrialData:updateStarRiverBtnRedPoint(state)
	Lua_MsgUtil.callFunc("UPDATE_STARRIVER_BTN", state);
end