-- 星河殿-章节Vo
checkRequire("Lua_StarTrialStarRewardVo");
Lua_StarTrialChapterVo = class("Lua_StarTrialChapterVo");
function Lua_StarTrialChapterVo:ctor(id)
	self.id = id;
	self:dispose();
end

function Lua_StarTrialChapterVo:dispose()
	self._config = nil;
	self._nextCfg = nil;
	self._starNum = 0;
	self._state = nil;
	self.stageVoArr = nil;
	self.canDraw = false;
	self.starRewardList = nil;
	self.isUnlockNewStage = false; -- 是否有新关卡解锁
end

function Lua_StarTrialChapterVo:updateStarTrialChapterVoInfo(msg)
	self.starNum = msg.star; -- 本章获得的星数
	self.state = msg.state; -- 挑战状态：0未解锁，1可挑战

	if self.stageVoArr == nil then
		self.stageVoArr = Array();
	end

	local obj;
	local vo;
	self.isUnlockNewStage = false;
	for i = 1, #msg.stage do
		obj = msg.stage[i];
		vo = DataCenter.starTrialUitl:getStageVo(obj.stage_id);
		vo:updateStarTrialStageVoInfo(obj);
		if self.stageVoArr:indexOf(vo) == -1 then
			self.stageVoArr:add(vo);
		end

		if obj.state == 1 and obj.stage_id ~= self.curStageId then -- 挑战状态：0未解锁，1挑战中，2挑战完成
			self.isUnlockNewStage = true;
			self.curStageId = obj.stage_id;
		end
	end
	self:updateStarRewardState(msg.reward); -- 星数奖励，key索引，value奖励状态：0不可领取，1可领取，2已领取
end

function Lua_StarTrialChapterVo.Get:starNum()
	return self._starNum;
end

function Lua_StarTrialChapterVo.Set:starNum(value)
	self._starNum = value;
end

function Lua_StarTrialChapterVo.Get:state()
	return self._state or 0;
end

function Lua_StarTrialChapterVo.Set:state(value)
	self._state = value;
end

function Lua_StarTrialChapterVo:updateStarRewardState(list)
	if self.starRewardList == nil then
		self.starRewardList = {};
	end

	local id;
	local drwaState;
	self.canDraw = false;
	for i = 1, #list do
		drwaState = tonumber(tostring(list[i].value));
		if drwaState == 1 then
			self.canDraw = true; -- value 0不可领取 1可领取 2已领取
		end

		id = tonumber(tostring(list[i].key));
		if self.starRewardList[id % 10000] == nil then
			self.starRewardList[id % 10000] = Lua_StarTrialStarRewardVo.new(id);
		end
		self.starRewardList[id % 10000]:updateStarRewardVoInfo(drwaState);
	end

	if Lua_WindowUtil.isWindowShowing("Lua_StarTrialStarRewardWindow") then
		Lua_MsgUtil.callFunc("UPDATE_REWARD_DATE", self.starRewardList);
	end
end

-- 是否满星（仅适用于请求过该章节信息）
function Lua_StarTrialChapterVo.Get:isMaxStar()
	return self.starNum >= self.total_star;
end

-- 是否全部关卡已通过（仅适用于请求过该章节信息）
function Lua_StarTrialChapterVo.Get:isPass()
	if self.stageVoArr == nil then
		return false;
	end
	return self.stageVoArr[self.stageVoArr:getSize()].state == 2;
end










function Lua_StarTrialChapterVo.Get:config()
	if self._config == nil then
		self._config = getConfig("star_trial_chatper", self.id);
	end
	return self._config;
end

-- 下一章节信息
function Lua_StarTrialChapterVo.Get:nextCfg()
	if self._nextCfg == nil and self.next_chapter ~= 0 then
		self._nextCfg = getConfig("star_trial_chatper", self.next_chapter);
	end
	return self._nextCfg;
end

-- 备注
function Lua_StarTrialChapterVo.Get:remark()
	return self.config.remark;
end

-- 上一章节
function Lua_StarTrialChapterVo.Get:prev_chapter()
	return self.config.prev_chapter;
end

-- 下一章节
function Lua_StarTrialChapterVo.Get:next_chapter()
	return self.config.next_chapter;
end

-- 总星数
function Lua_StarTrialChapterVo.Get:total_star()
	return self.config.total_star;
end

-- 等级限制
function Lua_StarTrialChapterVo.Get:limit_lvl()
	return self.config.limit_lvl;
end

-- 解锁下一章需要当前章节获得的星数
function Lua_StarTrialChapterVo.Get:unlock_star()
	return self.config.unlock_star;
end

-- 星数奖励
function Lua_StarTrialChapterVo.Get:star_reward()
	return self.config.star_reward;
end