-- 星河殿-关卡Vo
checkRequire("Lua_StarCondVo");
Lua_StarTrialStageVo = class("Lua_StarTrialStageVo");
function Lua_StarTrialStageVo:ctor(id)
	self.id = id;
	self:dispose();
end

function Lua_StarTrialStageVo:dispose()
	self._config = nil;
	self.starDic = nil;
end

function Lua_StarTrialStageVo:updateStarTrialStageVoInfo(msg)
	if self.starDic == nil then
		self:initStarInfo();
	end

	self.state = msg.state; -- 挑战状态：0未解锁，1挑战中，2挑战完成
	self.star = 0; -- 已获得星数
	for i = 1, #msg.star do
		self.starDic[msg.star[i].key] = msg.star[i].value == 0; -- key星数 value 0未获得 1已获得
		if msg.star[i].value == 1 then
			self.star = self.star + 1;
		end
	end
end

function Lua_StarTrialStageVo:initStarInfo()
	self.starDic = {};
	for i = 1, #self.star_cond do
		self.starDic[i] = true;
	end
end

function Lua_StarTrialStageVo.Get:isMaxStar()
	return self.star >= #self.starDic;
end

function Lua_StarTrialStageVo.Get:index()
	if self._index == nil then
		self._index = self.id % (self.chapter * 10000);
	end
	return self._index;
end

function Lua_StarTrialStageVo.Get:starCondArr()
	if self._starCondArr == nil then
		self._starCondArr = Array();

		local vo;
		for i = 1, #self.star_cond do
			vo = Lua_StarCondVo.new(Lua_FightDefine.TEMPLATE_ID_STARTRIAL);
			vo:parseCond(self.star_cond[i]);
			self._starCondArr:add(vo);
		end
	end
	return self._starCondArr;
end

-- 记录战斗状态
function Lua_StarTrialStageVo:recordBeforeFight()
	self.brforeFightState = self.state;
end










function Lua_StarTrialStageVo.Get:config()
	if self._config == nil then
		self._config = getConfig("star_trial_stage", self.id);
	end
	return self._config;
end

-- 章节
function Lua_StarTrialStageVo.Get:chapter()
	return self.config.chapter;
end

-- 上一关卡
function Lua_StarTrialStageVo.Get:prev_stage()
	return self.config.prev_stage;
end

-- 下一关卡
function Lua_StarTrialStageVo.Get:next_stage()
	return self.config.next_stage;
end

-- 星数条件
function Lua_StarTrialStageVo.Get:star_cond()
	return self.config.star_cond;
end

-- 等级限制
function Lua_StarTrialStageVo.Get:limit_lvl()
	if self.config.limit_lvl == nil then
		return 0;
	end
	return self.config.limit_lvl;
end

-- 关卡奖励
function Lua_StarTrialStageVo.Get:reward()
	if self.rewardVoArr == nil then
		self.rewardVoArr = Array();

		local rewardList = self.config.reward;
		local vo;
		for i = 1, #rewardList do
			vo = Lua_ToolVo.createToolVo(rewardList[i][1], rewardList[i][2]);
			self.rewardVoArr:add(vo);
		end
	end
	return self.rewardVoArr;
end

-- 关卡怪物
function Lua_StarTrialStageVo.Get:monster()
	return self.config.monster;
end

-- 关卡显示位置
function Lua_StarTrialStageVo.Get:stage_pos()
	return self.config.stage_pos;
end

-- 关卡图标类型
function Lua_StarTrialStageVo.Get:iconType()
	return self.config.icon_type;
end

-- 推荐战力
function Lua_StarTrialStageVo.Get:fightNum()
	return self.config.fight_num;
end