checkRequire("Lua_StarTrialChapterVo");
checkRequire("Lua_StarTrialStageVo");
Lua_StarTrialUtil = class("Lua_StarTrialUtil");
function Lua_StarTrialUtil:ctor()
	self:dispose();
end

function Lua_StarTrialUtil:dispose()
	self._chapterList = nil;
	self._stageList = nil;
	if self._chapterArr ~= nil then
		self._chapterArr:dispose();
		self._chapterArr:clear();
		self._chapterArr = nil;
	end
end

function Lua_StarTrialUtil.Get:getChapterArr()
	if self._chapterArr == nil then
		self._chapterArr = Array();

		local config = getConfig("star_trial_chatper");
		local vo;
		for k, v in pairs(config) do
			vo = self:getChapterVo(v.id);
			self._chapterArr:add(vo);
		end
		self._chapterArr:sort("id", false);
	end
	return self._chapterArr;
end

function Lua_StarTrialUtil:getChapterVo(id)
	if self._chapterList == nil then
		self._chapterList = {};
	end
	if self._chapterList[id] == nil then
		self._chapterList[id] = Lua_StarTrialChapterVo.new(id);
	end
	return self._chapterList[id];
end

function Lua_StarTrialUtil:getStageVo(id)
	if self._stageList == nil then
		self._stageList = {};
	end
	if self._stageList[id] == nil then
		self._stageList[id] = Lua_StarTrialStageVo.new(id);
	end
	return self._stageList[id];
end

function Lua_StarTrialUtil:getStateByStageId(id)
	local vo = self:getStageVo(id);
	return vo.state == 2;
end

function Lua_StarTrialUtil:getConstConfig(id, name)
	local config = getConfig("star_trial_const", id);
	if config ~= nil then
		return config[name];
	end
	return nil;
end

function Lua_StarTrialUtil:getSweepInfoById(id)
	return getConfig("star_trial_day_reward", id);
end

-- 滑块移动时间
function Lua_StarTrialUtil.Get:stageMoveTime()
	return getConfig("star_trial_const", "sub_move_time", "value");
end

-- 每次连线时间
function Lua_StarTrialUtil.Get:lineTime()
	return getConfig("star_trial_const", "line_time", "float_value");
end