Lua_ModelConfigData = class("Lua_ModelConfigData")
function Lua_ModelConfigData.getConfig(id)
	if id == nil or id <= 0 then
		return;
	end

	if Lua_ModelConfigData.configDic == nil then
		Lua_ModelConfigData.configDic = {};
	end

	if Lua_ModelConfigData.configDic[id] == nil then
		local config = getConfig("model", id);
	    if config == nil then
	    	return nil;
	    end
		Lua_ModelConfigData.configDic[id] = Lua_ModelConfigData.new(id, config);
	end
	return Lua_ModelConfigData.configDic[id];
end

function Lua_ModelConfigData:ctor(id, config)
	self:superCall("ctor");
	self.id = id;
	self._config = config;
end

function Lua_ModelConfigData.Get:config()
	if self._config then
		self._config = getConfig("model", self.id);
	end
	return self._config;
end

function Lua_ModelConfigData.Get:floder()
	return self.config.floder or "/model/";
end

function Lua_ModelConfigData.Get:modelUrl()
	if self._modelUrl == nil and self.fileName then
		self._modelUrl = LanUtil.StringProfile(self.floder, self.fileName);
	end
	return self._modelUrl;
end

function Lua_ModelConfigData.Get:fileName()
	return self.config.file_name;
end

function Lua_ModelConfigData.Get:modelName()
	return self.config.model_name;
end

function Lua_ModelConfigData.Get:mainLineBubbleRoot()
	return self.config.mainline_bubble_root or self.modelName;
end