checkRequire("Lua_TotemUtil")
checkRequire("Lua_TotemData")
Lua_TotemProxy = class("Lua_TotemProxy")
function Lua_TotemProxy:ctor()
	DataCenter.totemUtil = Lua_TotemUtil.new()
	DataCenter.totemData = Lua_TotemData.new()

	Lua_MsgUtil.addLuaMsg(50209001, self, self.rWear); -- 请求装备图腾（返回）
	Lua_MsgUtil.addLuaMsg(50209002, self, self.rRemove); -- 请求装备图腾（返回）
	Lua_MsgUtil.addLuaMsg(50209003, self, self.rStrengthen); -- 请求强化图腾（返回）
end

-------------------- 请求 --------------------
-- 请求装备图腾
function Lua_TotemProxy:sWear(hero_uid, uid_list, other_hero_uid)
	local cmd = ProtoPublic_pb.Proto10209001();
	-- 英雄唯一id
	cmd.hero_uid = tonumber(hero_uid);

	-- 图腾唯一id(道具唯一id)
	for i = 1, uid_list:getSize() do
		cmd.uid_list:append(tonumber(uid_list[i]));
	end
	uid_list = nil;

	-- 穿戴别的英雄身上图腾时，发英雄id
	cmd.other_hero_uid = tonumber(other_hero_uid);
	sendMsg(10209001, cmd);
end

-- 请求卸下图腾
function Lua_TotemProxy:sRemove(hero_uid, uid_list)
	local cmd = ProtoPublic_pb.Proto10209002();
	-- 英雄唯一id
	cmd.hero_uid = tonumber(hero_uid);

	-- 图腾唯一id(道具唯一id)
	for i = 1, uid_list:getSize() do
		cmd.uid_list:append(tonumber(uid_list[i]));
	end
	uid_list = nil;

	sendMsg(10209002, cmd);
end

-- 请求强化图腾
function Lua_TotemProxy:sStrengthen(totem_uid, selectedDic, hero_uid)
	local cmd = ProtoPublic_pb.Proto10209003();
	-- 图腾唯一id
	cmd.totem_uid = tonumber(totem_uid);

    local struct;
    local vo;
	for k, v in pairs(selectedDic) do
		vo = DataCenter.packData:getItemVoByUnId(k);
		if vo.main_type == Lua_PackDefine.TOTEM then
			-- 作为强化材料的图腾道具唯一id
			cmd.cost_totem_list:append(tonumber(k));
		else
			-- 图腾结晶道具id，value：数量
			struct = getProtoMsg("ProtoPairLong");
			struct.key = tonumber(vo.id);
			struct.value = tonumber(v);
			cmd.cost_item_list:addToList(struct);
		end
		selectedDic[k] = nil;
	end
	selectedDic = nil;

	-- 穿戴的英雄唯一id，不在英雄的填0
	cmd.hero_uid = tonumber(hero_uid);
	sendMsg(10209003, cmd);
end

-- 请求合成图腾
function Lua_TotemProxy:sSynthesis(totem_id, uid_list)
	local cmd = ProtoPublic_pb.Proto10209004();
	-- 选择要获得的图腾id
	cmd.totem_id = tonumber(totem_id);

	-- 用来合成的图腾列表
	local len = uid_list:getSize();
	local uniqueId;
	while len > 0 do
		uniqueId = uid_list:remove(len);
		cmd.uid_list:append(tonumber(uniqueId));
		len = len - 1;
	end
	uid_list = nil;
	sendMsg(10209004, cmd);
end

-------------------- 返回 --------------------

function Lua_TotemProxy:rWear(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80111001();
		msg:ParseFromString(mp.data);
		if msg.ret == 1 then
			OperateAlert.showLangValue(762039);
		else
			OperateAlert.showLangValue(762037);
		end
		Lua_WindowUtil.openWin("Lua_TotemItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_TotemReplaceWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_TotemProxy:rRemove(mp)
	if mp.errno == 0 then
		OperateAlert.showLangValue(762038);
		Lua_WindowUtil.openWin("Lua_TotemItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_TotemReplaceWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_TotemProxy:rStrengthen(mp)
	if mp.errno == 0 then
		OperateAlert.showLangValue(762043);
		Lua_MsgUtil.callFunc("TOTEM_STRENGTHEN_SUCCESS");
	end
end
