Lua_TotemUtil = class("Lua_TotemUtil")
function Lua_TotemUtil:ctor()
	self:superCall("ctor")
end

function Lua_TotemUtil:dispose()

end

-- 图腾合成消耗
function Lua_TotemUtil.Get:composeCount()
	return getConfig("totem_const", "compose_cost", "value") or 0;
end

-- 合成消耗
function Lua_TotemUtil.Get:composeCost()
	return getConfig("totem_const", "compose_cost", "json_value") or {};
end

-- 图腾筛选
function Lua_TotemUtil.Get:totemScreen()
	return getConfig("totem_const", "totem_screen", "json_value") or {};
end

-- 星级筛选
function Lua_TotemUtil.Get:starScreen()
	return getConfig("totem_const", "star_screen", "json_value") or {};
end

-- 固定显示属性
function Lua_TotemUtil.Get:showAttrList()
	return getConfig("totem_const", "show_attribute", "json_value") or {};
end

-- 图鉴配置
function Lua_TotemUtil:getHangbookConfig(id)
	return getConfig("totem_handbook", id);
end

-- 等级配置
function Lua_TotemUtil:getLevelConfig(id, level)
	return getConfig("totem_level", id * 100 + level);
end

-- 部位配置
function Lua_TotemUtil:getPartConfig(id)
	return getConfig("totem_part", id);
end

function Lua_TotemUtil:getPartUnlockLv(id)
	return getConfig("totem_part", id, "unlock_level") or 0;
end

-- 套装配置
function Lua_TotemUtil:getSuitConfig(id)
	return getConfig("totem_suit", id);
end










-- 图鉴列表
function Lua_TotemUtil:getHangbookArr()
	if self._hangbookArr == nil then
		self._hangbookArr = Array();
		local config = getConfig("totem_handbook");
		for k, _ in pairs(config) do
			self._hangbookArr:add(k);
		end
		quickSort(self._hangbookArr, nil, true);
	end
	return self._hangbookArr;
end

function Lua_TotemUtil:getAllTotemArr()
	if self._totemArr == nil then
		self._totemArr = Array();
		local id;
		for star = 2, 6 do -- 星级
			for t = 1, 12 do -- 类型
				for part = 1, 6 do -- 部位
					id = 219 * 1000000 + star * 10000 + t * 100 + part;
					self._totemArr:add(id);
				end
			end
		end
	end
	return self._totemArr;
end

-- 图腾列表-图腾类型
function Lua_TotemUtil:getTotemArrByType(subType, star)
	if self.totemDic == nil then
		self.totemDic = {};
		local arr = self:getAllTotemArr();
		local vo;
		for i = 1, arr:getSize() do
			vo = Lua_ToolVo.createToolVo(arr[i]);
			if self.totemDic[vo.sub_type] == nil then
				self.totemDic[vo.sub_type] = Array();
			end
			self.totemDic[vo.sub_type]:add(vo);
		end
	end

	local data = self.totemDic[subType];
	local arr = Array();
	for i = 1, data:getSize() do
		if data[i].star == star then
			arr:add(data[i]);
		end
	end
	return arr;
end

-- 随机属性文本ID
function Lua_TotemUtil:getRandomAttrLangId(star)
	if star < 3 then
		return LanUtil.getValue(762018);
	elseif star < 5 then
		return LanUtil.getValue(762019);
	end
	return LanUtil.getValue(762020);
end











-- 可升到n级 剩余n经验 消耗数量
function Lua_TotemUtil:getUpLeveAndLeftExp(id, level, curExp, addExp)
	local config = self:getLevelConfig(id, level);
	local costNum = 0;
	local needExp = config.exp or 0; -- 0=满级
	needExp = needExp - curExp;

	local bValue = true;
	while bValue do
		if needExp > 0 then
			if addExp - needExp >= 0 then
				if config.cost_item and #config.cost_item > 1 then
					costNum = costNum + config.cost_item[2] * needExp;
				end
				addExp = addExp - needExp;

				level = level + 1;
				config = self:getLevelConfig(id, level);
				needExp = config.exp or 0;
			else
				if config.cost_item and #config.cost_item > 1 then
					costNum = costNum + config.cost_item[2] * addExp;
				end
				bValue = false;
			end
		else
			bValue = false;
		end
	end
	return level, addExp, costNum;
end