checkRequire("Lua_CrackShotDiffVo");
Lua_CrackShotData = class("Lua_CrackShotData");
function Lua_CrackShotData:ctor()
end

function Lua_CrackShotData:dispose()
	self._challengeTimes = nil;
	self._limitBuyTimes = nil;
	self._itemCostInfo = nil;
	self._isFirst = nil;
	self.crackShotDiffTypeDic = nil;
	self._crackShotDiffTypeArr = nil;
	self._actOpenTime = nil;
	self._isCrackShotTween = nil;
end

function Lua_CrackShotData:fromServer50108060(msg)
	if msg == nil then
		return;
	end

	self._challengeTimes = msg.times; -- 可用次数
	self._limitBuyTimes = msg.buy_times; -- 剩余可购买次数，-1无限制
	self._itemCostInfo = msg.item_use; -- 道具购买次数消耗
	self._isFirst = msg.is_first == 1; -- 是否第一次打开 0否 1是

	local obj;
	local vo;
	if self._crackShotDiffTypeArr == nil then self._crackShotDiffTypeArr = Array(); end
	for i = 1, #msg.type_info do
		obj = msg.type_info[i];
		vo = self:getDiffTypeInfoByDiffType(obj.type);
		if vo == nil then
			vo = Lua_CrackShotDiffVo.new(obj.type);
			self._crackShotDiffTypeArr:add(obj.type);
			self.crackShotDiffTypeDic[obj.type] = vo;
		end
		vo:updateCrackShotDiffVoInfo(obj);
	end
end

function Lua_CrackShotData.Get:challengeTimes()
	return self._challengeTimes or 0;
end

function Lua_CrackShotData.Get:limitBuyTimes()
	return self._limitBuyTimes or 0;
end

function Lua_CrackShotData.Get:itemCostInfo()
	return self._itemCostInfo or 0;
end

function Lua_CrackShotData.Get:isFirst()
	return self._isFirst or false;
end

function Lua_CrackShotData:getDiffTypeInfoByDiffType(diffType)
	if self.crackShotDiffTypeDic == nil then
		self.crackShotDiffTypeDic = {};
	end
	if diffType == nil or self.crackShotDiffTypeDic[diffType] == nil then
		return nil;
	end
	return self.crackShotDiffTypeDic[diffType];
end

function Lua_CrackShotData.Get:crackShotDiffTypeArr()
	self._crackShotDiffTypeArr:sort(nil, false);
	return self._crackShotDiffTypeArr;
end

function Lua_CrackShotData.Get:actOpenTime()
	return self._actOpenTime or 0;
end

function Lua_CrackShotData.Set:actOpenTime(value)
	self._actOpenTime = value;
end

function Lua_CrackShotData:fromServer50108061(msg)
	if msg == nil then
		return;
	end

	local obj;
	local redState = false;
	for i = 1, #msg.task_info do
		obj = msg.task_info[i];
		if not redState and obj.info1 == 1 then
			redState = true;
			break;
		end
	end
	if msg.type == 1 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CrackShot_Task_Daily, redState);
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CrackShot_Task_Cumulate, redState);
	end
end

function Lua_CrackShotData:getEffectName(showResult)
	local effectName;
	if showResult == 1 then
		effectName = "ui_bfb_mz_p"; -- 完美/perfect
	elseif showResult == 2 then
		effectName = "ui_bfb_mz_g"; -- 很好/great
	end
	return effectName;
end

function Lua_CrackShotData.Get:isCrackShotTween()
	return self._isCrackShotTween or false;
end

function Lua_CrackShotData.Set:isCrackShotTween(val)
	if self._isCrackShotTween ~= val then
		self._isCrackShotTween = val;
		DataCenter.loginData:checkFpsState();
		if not val then
			DataCenter.popupWinManager:checkPopupWin();
		end
	end
end