Lua_CrackShotDiffVo = class("Lua_CrackShotDiffVo");
function Lua_CrackShotDiffVo:ctor(diffType)
	self.diffType = diffType; -- 难度
end

function Lua_CrackShotDiffVo:dispose()
	self.speed = nil;
	self.progressRewardDic = nil;
	self._maxCheckAngleRange = nil;
end

function Lua_CrackShotDiffVo:updateCrackShotDiffVoInfo(msg)
	self.open_time = msg.open_time; -- 开启时间（剩余XX秒）
	self.open_level = msg.open_level; -- 开启等级
	self.top_score = msg.top_score; -- 最高分
	self.sub_type_list = msg.sub_type_list; -- 关卡库
	self.top_player = msg.top_player; -- 最高分玩家信息

	if self.progressRewardDic == nil then
		self.progressRewardDic = {};
	end -- 阶段奖励

	table.sort( msg.progress_reward, function(a, b) return tonumber(tostring(a.cond_int)) < tonumber(tostring(b.cond_int)); end );
	local obj;
	for i = 1, #msg.progress_reward do
		obj = msg.progress_reward[i];
		self.progressRewardDic[i] = {
			index = i,
			diffType = self.diffType,
			score = tonumber(tostring(obj.cond_int)),
			drawState = obj.state,
			itemList = obj.item_list
		};
	end

	-- key 轮次左值 value 轮次右值 other 速度倍数 
	table.sort( msg.speed, function(a, b) return a.key < b.key; end );
	self.speed = msg.speed; -- 速度倍数

	local angle;
	local list = msg.grade_angle;
	table.sort( list, function(a, b) return a.key < b.key; end ); -- 得分角度 key角度 value分数
	self.scoreDic = {};
	for i = 1, #list do
		if angle == nil or angle < list[i].key then
			angle = list[i].key;
		end
		self.scoreDic[list[i].value] = i; -- 数字越小成绩越好
	end
	self._maxCheckAngleRange = angle;
end

function Lua_CrackShotDiffVo.Get:maxCheckAngleRange()
	return self._maxCheckAngleRange or 0;
end

function Lua_CrackShotDiffVo.Get:selectLevelGrade()
	local num = #self.sub_type_list;
	local idx = Mathf.Random(1, num); -- 重新随机
	return self.sub_type_list[idx];
end

function Lua_CrackShotDiffVo.Get:timeCond()
	return self.open_time > 0;
end

function Lua_CrackShotDiffVo.Get:lvCond()
	return DataCenter.roleData.level < self.open_level;
end

function Lua_CrackShotDiffVo:getShowGrade(score)
	if score == nil or self.scoreDic == nil or self.scoreDic[score] == nil then
		return 0;
	end
	return self.scoreDic[score];
end

function Lua_CrackShotDiffVo:getCurSpeed(minRound)
	if minRound == nil or self.speed == nil then
		return 1;
	end

	local speed = self.speed[#self.speed].value;
	for i = 1, #self.speed do
		if minRound <= self.speed[i].value then
			speed = self.speed[i].other;
			break;
		end
	end
	return speed;
end